//bugs: fskip impares causan perdida de setcolors en emulacion

#define FGBZ_TURBOFSKIP 15

#define FGBZ_ROMSDIR "0:/PALM/Programs/LJZ/GB/Roms/" //"gp:\\snes\\ffmq11.zip"
#define FGBZ_SAVESDIR "0:/PALM/Programs/LJZ/GB/Saves/" //"gp:\\snes\\ffmq11.zip"
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

#define MAX_FRAME_SKIPPED 10


#include "stdio.h"
#include "stdlib.h"
#include "font.h"

#include "defs.h"
#include "regs.h"



#include "lcd.h"

#include "fb.h"
#include "input.h"
#include "rc.h"
#include "pcm.h"
#include "mem.h"
#include "hw.h"
#include "rtc.h"
#include "sound.h"

#include "save.h"

#include "zodiac.h"

#include "sys/stat.h"

/*****************/
#include "LJZmenu.h"
/**************************/

TwGfxType *fgbZ_mGfxLib;
TwGfxSurfaceType *fgbZ_curRenderingScreen,*fgbZ_RenderingScreen[2];
uint16 *fgbZ_curRenderingScreenPtr,*fgbZ_RenderingScreenPtr[2];
uint32 fgbZ_curRenderingScreenIndex;
uint32 fgbZ_enabledSound,fgbZ_sndfreq;
uint32 fgbZ_renderingmode;
uint32 fgbZ_padState;
uint32 fgbZ_mGBPal=0;
int32 fgbZ_frameskipped,fgbZ_frameskip,fgbZ_fastforward;
int32 fgbZ_frameBeginTime;
int32 fgbZ_speedpct;
int32 fgbZ_autofireA,fgbZ_autofireB;
int32 fgbZ_framecount;

TwInputHandle fgbZ_mInputQueue;
Int32 fgbZ_inputFormats[] = { twInputTimeStamp };
typedef struct {Int32 mTime;} fgbZ_ZUserEvent;
fgbZ_ZUserEvent fgbZ_mUserEvent;
Int32* fgbZ_mInputFormat;        

char CurrentROMFile[256];
char fgbZ_curVolume;
char shortrom_filename[64];

unsigned long fgbZ_romCrc;

int emu_running;
int framelimit_delay;

void state_save(int n);
int state_load(int n,int only_check);


char str_month[12][4]=
{"Jan","Feb","Mar","Apr","May","Jun",
"Jul","Aug","Sep","Oct","Nov","Dec"};

#define BLACK_COLOR 255



void fgbZ_pause(int pause);

int Z_KeyGet(void)
{
	return fgbZ_padState;
}

int32 fgbZ_getTickCount()
{
	//TODO return tick 
	/*long long l;
	l=TimGetTicks();	
	return l*1000/SysTicksPerSecond();*/
	
  	TwInputPoll(fgbZ_mInputQueue, (Int32 *) &fgbZ_mUserEvent, sizeof(fgbZ_mUserEvent));  	  	      	
	return fgbZ_mUserEvent.mTime;
}


int init_video(void)
{
	//Init vid
	TwGfxSurfaceInfoType surfInfo;
	surfInfo.size = sizeof(surfInfo);
	surfInfo.width = 256; //must be / 4
	surfInfo.height = 144;
	surfInfo.location = twGfxLocationAcceleratorMemoryNoBackingStore;
	surfInfo.pixelFormat = twGfxPixelFormatRGB565;
	xassert(TwGfxAllocSurface(fgbZ_mGfxLib, &fgbZ_RenderingScreen[0], &surfInfo));
	xassert(TwGfxAllocSurface(fgbZ_mGfxLib, &fgbZ_RenderingScreen[1], &surfInfo));

	if (TwGfxLockSurface(fgbZ_RenderingScreen[0], (void**)&fgbZ_RenderingScreenPtr[0]))
	{
	   return 1;
	}
	if (TwGfxLockSurface(fgbZ_RenderingScreen[1], (void**)&fgbZ_RenderingScreenPtr[1]))
	{
	   return 1;
	}
	
	memset(fgbZ_RenderingScreenPtr[0],0,256*144*2);
	memset(fgbZ_RenderingScreenPtr[1],0,256*144*2);
	
	fgbZ_curRenderingScreenIndex=0;
	fgbZ_curRenderingScreen=fgbZ_RenderingScreen[fgbZ_curRenderingScreenIndex];
	fgbZ_curRenderingScreenPtr=fgbZ_RenderingScreenPtr[fgbZ_curRenderingScreenIndex];
	
	
	signed long val1,val2,val;
	FtrGet(APPLI_ID,FTR_OPT_SCREENMODE_ID,(unsigned long*)&val1);
	FtrGet(APPLI_ID,FTR_OPT_SMOOTHING_ID,(unsigned long*)&val2);
	if (!val1) fgbZ_renderingmode=0;
	else 
	if (val1==1) fgbZ_renderingmode=(val2?2:1);
	else
	if (val1==2) fgbZ_renderingmode=(val2?4:3);
	else
	fgbZ_renderingmode=(val2?6:5);
	

	

	fgbZ_fastforward=0;
	
	fgbZ_frameskipped=0;
	
	 FtrGet(APPLI_ID,FTR_OPT_FSKIP_ID,(unsigned long*)&val);     
	fgbZ_frameskip=val;
	

    /*input*/
    TwInputOpen(&fgbZ_mInputQueue, "twinput", "r");
  fgbZ_mInputFormat = (Int32*)ljz_malloc(sizeof(Int32)*sizeof(fgbZ_inputFormats)/sizeof(fgbZ_inputFormats[0]));
  memmove(fgbZ_mInputFormat, fgbZ_inputFormats, sizeof(fgbZ_inputFormats));
  TwInputSetFormat(fgbZ_mInputQueue, fgbZ_mInputFormat, sizeof(fgbZ_inputFormats));    
  TwInputActivate(fgbZ_mInputQueue);

	return 0;
}

struct fb fb;

byte vidram[160*144*2];

void vid_preinit(void) {}
void vid_init(void)
{


       fb.w = 160;
       fb.h = 144;
       fb.pelsize = 2;
       fb.pitch = 160*2;
       fb.ptr = (unsigned char *)&vidram[0]; //0x0C7B4000;
       fb.enabled = 1;
       fb.dirty = 1; ///1????
       fb.yuv = 0;

       fb.indexed = 0;
       fb.cc[0].l = 11; fb.cc[0].r = 3;
       fb.cc[1].l = 5; fb.cc[1].r = 2;
       fb.cc[2].l = 0; fb.cc[2].r = 3;
}
void vid_begin(void)
{
	fgbZ_framecount++;
}

int tick=0;
int frames_rendered=0,frames_displayed=0; 
char fps_string[64];

void fgbZ_asmfastrender(byte *screen,byte *source)
{
	__asm{
		stmfd r13!,{r2-r12}
	
		mov	  r2,#144

	 loopY:	
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		ldmia r1!,{r3-r12}
		stmia r0!,{r3-r12}
		
		add	  r0,r0,#192 //(256-160) * 2
		
		subs  r2,r2,#1
		bne   loopY
		
		ldmfd r13!,{r2-r12}	
		}	
}

int Do_Nothing(void)
{
	int j=0;
	j+=1;
	return j;
}


void vid_end(void)
{

	
	if (fb.enabled)
	{
	
		TwGfxPointType destLocation = {0, 0};
	    TwGfxSurfaceType* displaySurface;
		TwGfxRectType mDisp;
		mDisp.x=0;
		mDisp.y=0;
		mDisp.w=160;
		mDisp.h=144;
    	// Get palmos display surface:
	    xassert(TwGfxGetPalmDisplaySurface(fgbZ_mGfxLib, &displaySurface));	
    
	    fgbZ_asmfastrender((byte*)fgbZ_curRenderingScreenPtr,(byte*)vidram);
    
		switch (fgbZ_renderingmode)
		{
		case 0:
		{						
			destLocation.x=(480-160)>>1;
			destLocation.y=(320-144)>>1;
			if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
				xassert(TwGfxBitBlt(displaySurface, &destLocation, fgbZ_curRenderingScreen, &mDisp));
			break;
		}		
		case 1:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-356)>>1;
				mDispDest.y=0;
				mDispDest.w=356;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}	
		case 2:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-356)>>1;
				mDispDest.y=0;
				mDispDest.w=356;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}				

			
		case 3:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}							
		case 4:
			{
				TwGfxRectType mDispDest;
				mDispDest.x=0;
				mDispDest.y=0;
				mDispDest.w=480;
				mDispDest.h=320;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}							
		case 5:
		{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-320)>>1;
				mDispDest.y=(320-288)>>1;
				mDispDest.w=320;
				mDispDest.h=288;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast));
				break;
			}
		case 6:
		{
				TwGfxRectType mDispDest;
				mDispDest.x=(480-320)>>1;
				mDispDest.y=(320-288)>>1;
				mDispDest.w=320;
				mDispDest.h=288;
				if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
					xassert(TwGfxStretchBlt2(displaySurface, &mDispDest, fgbZ_curRenderingScreen, &mDisp,twGfxStretchFast|twGfxStretchSmooth));
				break;
			}
		
		}
		fgbZ_curRenderingScreenIndex^=1;
		fgbZ_curRenderingScreen=fgbZ_RenderingScreen[fgbZ_curRenderingScreenIndex];
		fgbZ_curRenderingScreenPtr=fgbZ_RenderingScreenPtr[fgbZ_curRenderingScreenIndex];
	}
	
	frames_displayed++;	
	fgbZ_frameBeginTime+=17*100/fgbZ_speedpct;	//60Hz				
	
	if ((fgbZ_frameskip==AUTO_FSKIP)&&(!fgbZ_fastforward))
	{
		int i,haswaited=0;
		
		//do avoid issue when Tick is looping
		if ((int32)(fgbZ_frameBeginTime-fgbZ_getTickCount())>=(int32)(10*17))		
			fgbZ_frameBeginTime=fgbZ_getTickCount()+17;				
		//while (fgbZ_getTickCount()<=fgbZ_frameBeginTime)  haswaited=1;
		i=fgbZ_frameBeginTime-fgbZ_getTickCount()+1;
        if (i>0) {haswaited=1; SysTaskDelay(i);}
		
		if (haswaited||(fgbZ_frameskipped>=MAX_FRAME_SKIPPED)) 
		{
			fb.enabled=1;
			fgbZ_frameskipped=0;
		}
		else 
		{
			fb.enabled=0;
			fgbZ_frameskipped++;
		}
	}
	else
	{	
		if (fgbZ_frameskip==SKEEZIX_FSKIP) fgbZ_frameskipped=SKEEZIX_FSKIP;	
		fgbZ_frameskipped++;
		
		if (fgbZ_fastforward)
		{
			if (fgbZ_frameskipped>FGBZ_TURBOFSKIP)
			{
				fgbZ_frameskipped=0;
				fb.enabled=1;
			}
			else fb.enabled=0;
		}
		else
		{					
			if (fgbZ_frameskipped>fgbZ_frameskip)
			{
				fgbZ_frameskipped=0;
				fb.enabled=1;
				int i;						
				
				//do avoid issue when Tick is looping				
				if ((int32)(fgbZ_frameBeginTime-fgbZ_getTickCount())>=(int32)(10*17))				
					fgbZ_frameBeginTime=fgbZ_getTickCount()+17;
				//while (fgbZ_getTickCount()<=fgbZ_frameBeginTime) haswaited=1;
				i=fgbZ_frameBeginTime-fgbZ_getTickCount()+1;
		        if (i>0) {SysTaskDelay(i);}
	 		   			   										
			}
			else 
			{
				int i;
				fb.enabled=0;				
				if ((int32)(fgbZ_frameBeginTime-fgbZ_getTickCount())>=(int32)(10*17))				
					fgbZ_frameBeginTime=fgbZ_getTickCount()+17;
				if (fgbZ_enabledSound==2)
				{
					//while (fgbZ_getTickCount()<=fgbZ_frameBeginTime) ;
					i=fgbZ_frameBeginTime-fgbZ_getTickCount()+1;
			        if (i>0) {SysTaskDelay(i);}
				}
			}
		}
	}
	
}
void vid_close(void) {}

void vid_settitle(void) {}
int monopal_backup[256];
void vid_setpal(int i, int r, int g, int b)
{
 /*if (i>=253)  return;
 if (hw.cgb) SetColor(i,r,g,b); 
  else {
       switch(fgbZ_mGBPal)
       {
        case 0: SetColor(i,g/2,g,0);break;   //green
        case 1: SetColor(i,g*3/4,g,0);break; //lime
        case 2: SetColor(i,g,g,0);break;     //yellow
        case 3: SetColor(i,g,g,g);break;     //gray
        case 4: SetColor(i,0,g*3/4,g);break; //indigo
       }
       monopal_backup[i]=g;
       }*/
}

void ev_poll(void)
{
 int Key=Z_KeyGet();

 hw.pad=0;

 if(Key&KEY_UP)     hw.pad|=PAD_UP;

 if(Key&KEY_DOWN)   hw.pad|=PAD_DOWN;

 if(Key&KEY_LEFT)   hw.pad|=PAD_LEFT;

 if(Key&KEY_RIGHT)  hw.pad|=PAD_RIGHT;

 if(Key&KEY_A) 
 {
	 switch (fgbZ_autofireA)
	 {
  		case 0:hw.pad|=PAD_A; break;
  		case 1:
  	  		if ((fgbZ_framecount&31)>15) hw.pad|=PAD_A;
  	  		break;
  		case 2:
  	  		if ((fgbZ_framecount&15)>7) hw.pad|=PAD_A;
  	  		break;
  		case 3:
  	  		if ((fgbZ_framecount&7)>3) hw.pad|=PAD_A;
  	  		break;  		   
  	 }
  }  		
    
 if(Key&KEY_B)
 {
 	 switch (fgbZ_autofireB)
	 {
  		case 0:hw.pad|=PAD_B; break;
  		case 1:
  	  		if ((fgbZ_framecount&31)>15) hw.pad|=PAD_B;
  	  		break;
  		case 2:
  	  		if ((fgbZ_framecount&15)>7) hw.pad|=PAD_B;
  	  		break;
  		case 3:
  	  		if ((fgbZ_framecount&7)>3) hw.pad|=PAD_B;
  	  		break;  		   
  	 }
 }
 if(Key&KEY_SELECT) hw.pad|=PAD_SELECT;
 if(Key&KEY_START)  hw.pad|=PAD_START;

 pad_refresh();


}







void GetInfo(byte *header)
{

}


rcvar_t vid_exports[] =
{
	RCV_END
};

rcvar_t joy_exports[] =
{
	RCV_END
};

struct pcm pcm;
rcvar_t pcm_exports[] =
{
	RCV_END
};



#include "SoundMgr.h"
static SndStreamRef snd_stream;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;


static Err fgbZ_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	sound_mix(bufferZ,frameCountZ);
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


/*static void audio_callback(void *blah, byte *stream, int len)
{
       sound_mix();
       memcpy(stream, pcm.buf, len);
}*/


void pcm_init(void)
{
   __asm 
  {
  	ldr  r0, = reg_sys
  	add	 r0,r0,r10
  	str	 r9,[r0]
  	str	 r10,[r0,#4]
  } 
  /*if (fgbZ_enabledSound) */



       pcm.hz = fgbZ_sndfreq;
       pcm.stereo = 1;
       pcm.len = 512;//22050/60;
       pcm.buf = NULL;//ljz_malloc(pcm.len);
	   pcm.pos = 0;
	   
  
	   
       //memset(pcm.buf, 0, pcm.len);

/*       sndbuf.freq=PCM_M22; 
       sndbuf.format=PCM_8BIT; 
       sndbuf.samples=22050/60;
       sndbuf.userdata=NULL;
       sndbuf.callback=audio_callback;
       sndbuf.pollfreq=100;*/
}

int pcm_submit()
{
	if (!pcm.buf) return 0;
	if (pcm.pos < pcm.len) return 1;

	pcm.pos = 0;
	return 1;
}

void pcm_close(void)
{
	fgbZ_pause(1);
}


extern char *romfile;


byte *loadfile(FILE *fp, int *len)
{
	byte *d; 
	long romsize;
	char str[256];
	FILE *f;
	char gb_file[256];
	  char ext[5];
	  int	err_code;
	  unzFile zip_file = 0;    
	  unz_file_info unzinfo;
	  char *pext;
	 char *p;	
	
	pext = (char*)strrchr(romfile, '.');
  	if (pext) strncpy(ext, pext, sizeof(ext));
  	strlwr(ext);
  	if (strcmp(ext, ".zip") == 0)  
  	{  	  	
	  	zip_file = unzOpen(romfile);			                              
        if (!zip_file) return NULL;                                        
        unzGoToFirstFile (zip_file);                    
        for (;;) 
        {
        	if (unzGetCurrentFileInfo(zip_file, &unzinfo, gb_file, sizeof(gb_file), NULL, NULL, NULL, NULL) != UNZ_OK) return NULL;

         	    strlwr(gb_file); 
                p = (char *)strrchr(gb_file, '.');                                
                if (strcmp(p, ".gb") == 0) break;
                if (strcmp(p, ".gbc") == 0) break;
                if (unzGoToNextFile(zip_file) != UNZ_OK) return NULL;
         }         
         unzOpenCurrentFile (zip_file);

	 	romsize = unzinfo.uncompressed_size;	 	 	 
		d=(uint8 *)ljz_malloc(romsize);
		unzReadCurrentFile(zip_file, d, romsize);         
	    unzCloseCurrentFile (zip_file);
	    unzClose (zip_file);
  	
	}
	else
	{
	
	    f=fopen(romfile,"rb");		
  		if (!f) {  	
	  		//GpTextOut(NULL,&gpDraw[nflip],160,10,(char*)"File access error",0xe0);
	  		//	DrawMessage("error at opening",1);
	  		menu_message("error at opening");menu_waitPen(NULL,NULL,1);
  			return NULL;
		}  	
		fseek(f,-1,SEEK_END); //bug in palmos until now...
	  	romsize=ftell(f)+1;
	  	fseek(f,0,SEEK_SET);		
  	
	  	d=(byte *)ljz_malloc(romsize);
  		if (!d)
	  	{  		  		
			fclose(f);
  			return NULL;
	  	}
		if (fread(d,romsize,1,f)!=1/*romsize*/)	
		{
			fclose(f);
			ljz_free(d);
			return NULL;
		}
		fclose(f);			

		
	}
	*len=romsize;		
	return d;
}

int sram_load()
{
	if (!mbc.batt) return -1;
	/* Consider sram loaded at this point, even if file doesn't exist */
	ram.loaded = 1;
	
	char savename[255],result[256];
	byte i=0,j=255,k=255,l=255;
	char chaine[256];
	FILE *f;
  
	i=0;
	j=255;
	k=-1;
	while (CurrentROMFile[i]!=0) 
	{
		if (CurrentROMFile[i]=='.') j=i;
		if (CurrentROMFile[i]=='/') k=i;
		if (CurrentROMFile[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,CurrentROMFile+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	strcat(result,"srm");
	sprintf(savename,"%s%s",FGBZ_SAVESDIR,result);
	savename[0]=fgbZ_curVolume+'0';
	
	f=fopen(savename,"rb");
	if (f)
	{
		fread((void *)&ram.sbank[0],8192*mbc.ramsize,1,f);
		fclose(f);
	}
	else
	{
		sprintf(chaine,"Cannot open %s for loading\n",savename);   
//		DrawMessage(chaine,1);
		//menu_message(chaine);menu_waitPen(NULL,NULL,1);
	}
	
	return 0;
}

int sram_save()
{
	/* If we crash before we ever loaded sram, DO NOT SAVE! */
    if (!mbc.batt || !ram.loaded || !mbc.ramsize)  return -1;	
    
	if (!mbc.batt) return -1;
	/* Consider sram loaded at this point, even if file doesn't exist */
	ram.loaded = 1;
	
	char savename[255],result[256];
	byte i=0,j=255,k=255,l=255;
	char chaine[256];
	FILE *f;
  
	i=0;
	j=255;
	k=-1;
	while (CurrentROMFile[i]!=0) 
	{
		if (CurrentROMFile[i]=='.') j=i;
		if (CurrentROMFile[i]=='/') k=i;
		if (CurrentROMFile[i]=='\\') k=i;
		i++;
	  }
	if (j==255) j=i;  //pas d'extension	  
	memcpy(result,CurrentROMFile+k+1,j+1-k-1);    
	result[j+1-k-1]=0;
	strcat(result,"srm");
	sprintf(savename,"%s%s",FGBZ_SAVESDIR,result);
	savename[0]=fgbZ_curVolume+'0';
	
	f=fopen(savename,"w+b");
	if (f)
	{
		fwrite((void *)&ram.sbank[0],8192*mbc.ramsize,1,f);
		fclose(f);
	}
	else
	{
		sprintf(chaine,"Cannot open %s for saving\n",savename);   
		menu_message(chaine);menu_waitPen(NULL,NULL,1);
//		DrawMessage(chaine,1);

	}
	
	return 0;    

}

void GetStateFileName(int n,char *str)
{
  char result[256];
  byte i=0,j=255,k=255,l=255;

  
  
  i=0;
  j=255;
  k=-1;
  while (CurrentROMFile[i]!=0) 
  {
	if (CurrentROMFile[i]=='.') j=i;
	if (CurrentROMFile[i]=='/') k=i;
	if (CurrentROMFile[i]=='\\') k=i;
	i++;
  }
  if (j==255) j=i;  //pas d'extension	  
  memcpy(result,CurrentROMFile+k+1,j+1-k-1);    
  result[j+1-k-1]=0;
  if (n>=0)
  {
	  strcat(result,"ss");
	  sprintf(str,"%s%s%d",FGBZ_SAVESDIR,result,n);
  } 
  else 
  {
  	strcat(result,"srm");
  	sprintf(str,"%s%s",FGBZ_SAVESDIR,result);
  }
  str[0]=fgbZ_curVolume+'0';
}

void state_save(int n)
{	
  char savename[255];
  FILE *f;
 char chaine[256];  
  GetStateFileName(n,savename);
	
  f=fopen(savename,"w+b");
  if (f) 
  {
 	savestate(f);
	fclose(f);
  }
  else 
  {
    sprintf(chaine,"Cannot open %s for saving\n",savename);   
//	DrawMessage(chaine,1);
	menu_message(chaine);menu_waitPen(NULL,NULL,1);
  }
}


int state_load(int n,int only_check)
{
  char savename[255];   
  FILE *f;
 char chaine[256];  
  GetStateFileName(n,savename);
   	
  f=fopen(savename,"rb");
  if (f) 
  {
  	if (only_check) 
  	{
	  	fclose(f);
  		return 1;
  	}
 	loadstate(f);
	fclose(f);
  }
  else 
  {
	if (only_check) return 0;  	
    sprintf(chaine,"Cannot open %s for loading\n",savename);   
	//DrawMessage(chaine,1);
	menu_message(chaine);menu_waitPen(NULL,NULL,1);
  }
  
  vram_dirty();
  pal_dirty();
  sound_dirty();
  mem_updatemap();
  
  return 1;
}



int fgbZ_loadrom(void)
{
	ljz_std_showstat();
	int val;
	FtrGet(APPLI_ID,FTR_OPT_SOUND_ID,(unsigned long*)&val);  
	fgbZ_enabledSound=val;
	
	FtrGet(APPLI_ID,FTR_OPT_SOUNDFREQ_ID,(unsigned long*)&val);  
	if (val==1) fgbZ_sndfreq=22050;
	else if (val==2) fgbZ_sndfreq=11025;
	else fgbZ_sndfreq=44100;
	
	fgbZ_speedpct=100;
	fgbZ_autofireA=0;
	fgbZ_autofireB=0;
	
	fgbZ_framecount=0;

	init_video();

	vid_init();

	pcm_init();

	char *ftrptr;
    strcpy(CurrentROMFile,FGBZ_ROMSDIR);    
    FtrGet(APPLI_ID,FTR_ROM_FILENAME_ID ,(unsigned long*)&ftrptr);
    
    fgbZ_curVolume=ftrptr[0];
    CurrentROMFile[0]=fgbZ_curVolume+'0';
    
    ftrptr+=3;
	strcpy(shortrom_filename,ftrptr);  
    strcat(CurrentROMFile,ftrptr);
    FtrPtrFree(APPLI_ID, FTR_ROM_FILENAME_ID);
    
    char strload[128];
    sprintf(strload,"Loading : %s",shortrom_filename);
    menu_message(strload);

	loader_init(CurrentROMFile);
    emu_running=1;

	emu_reset();
    frames_rendered=frames_displayed=0;
    framelimit_delay=0;


	
	fgbZ_frameBeginTime=fgbZ_getTickCount();    
	emu_run();		
	
	fgbZ_pause(0);
    return 0; 
}

void fgbZ_MainLoop()
{
	emu_doframe();
	
	//process key
	int key=Z_KeyGet();
	if (key&KEY_QUICKLOAD)
	{
		if (state_load(0,1))
		{
			if (menu_confirm("Load state ?")) state_load(0,0);
			fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;
		}
	}
	if (key&KEY_QUICKSAVE)
	{
		if (menu_confirm("Save state ?")) state_save(0);
		fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;
	}
	if (key&KEY_TURBO)
	{		
		fgbZ_fastforward=1;		
	}
	else 
	if (fgbZ_fastforward)
	{
		fgbZ_fastforward=0;
		fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;
	}
}

void fgbZ_end()
{
//	if (!FrmAlert(FrmAlertSaveState)) state_save(0);
	sram_save();

	pcm_close();
    loader_unload();
    FUX0R_PAL();
    
    
	  TwGfxUnlockSurface(fgbZ_RenderingScreen[0],0);
	  TwGfxUnlockSurface(fgbZ_RenderingScreen[1],0);

	  if (fgbZ_RenderingScreen[0]) TwGfxFreeSurface(fgbZ_RenderingScreen[0]);
	  if (fgbZ_RenderingScreen[1]) TwGfxFreeSurface(fgbZ_RenderingScreen[1]);
  
	  TwInputClose(fgbZ_mInputQueue);  	
	  ljz_free(fgbZ_mInputFormat);    
  
  
    int val;
 	if ((fgbZ_renderingmode)&&(!(fgbZ_renderingmode&1))) FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,1);
	else FtrSet(APPLI_ID, FTR_OPT_SMOOTHING_ID,0);	
	FtrSet(APPLI_ID, FTR_OPT_SOUND_ID,fgbZ_enabledSound);
	switch (fgbZ_sndfreq)
	{
		case 11025:val=2;break;
		case 22050:val=1;break;
		default:val=0;break;
	}
	FtrSet(APPLI_ID, FTR_OPT_SOUNDFREQ_ID,val);
	
	FtrSet(APPLI_ID, FTR_OPT_SCREENMODE_ID,((fgbZ_renderingmode+1)>>1));
	
	FtrSet(APPLI_ID, FTR_OPT_FSKIP_ID,fgbZ_frameskip);
	
	ljz_std_showstat();
}

int fgbZ_setupenv(TwGfxType* mGfxLib)
{
	fgbZ_mGfxLib=mGfxLib;
	return 0;
}

void fgbZ_changefskip(void)
{
	char tmp[64];
	int i;
	

	fgbZ_frameskip++;
	if (fgbZ_frameskip>SKEEZIX_FSKIP) fgbZ_frameskip=0;
	
	
	if (fgbZ_frameskip==AUTO_FSKIP) sprintf(tmp,"Frameskip : AUTO");
	else if (fgbZ_frameskip==SKEEZIX_FSKIP) sprintf(tmp,"Frameskip : Skeezix");
	else sprintf(tmp,"Frameskip : %d",fgbZ_frameskip);	

	menu_message(tmp);
	
	i=fgbZ_getTickCount();
	while ((fgbZ_getTickCount()-i)<300)
	{
	}
	fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;
}
void fgbZ_changerendering(void)
{

	fgbZ_renderingmode++;
	if (fgbZ_renderingmode==7) fgbZ_renderingmode=0;
/*	if (fgbZ_renderingmode>=5) StatHide();
	if (fgbZ_renderingmode==0) StatShow();*/
	menu_message("Changing screen mode");
	fgbZ_frameBeginTime=fgbZ_getTickCount();
	while ((fgbZ_getTickCount()-fgbZ_frameBeginTime)<300)
	{
	}
	fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;

}
void fgbZ_updatevpad(unsigned int val)
{
	fgbZ_padState=val;	

}
void fgbZ_pause(int pause)
{
	if (pause)
	{
		if (fgbZ_enabledSound==2) 
		{
			SndStreamStop(snd_stream);
			SndStreamDelete(snd_stream);
		}
	}
	else
	{
		fgbZ_frameBeginTime=fgbZ_getTickCount()+17*100/fgbZ_speedpct;
		if (fgbZ_enabledSound==2) 
		{
			SndStreamCreate(&snd_stream,sndOutput,fgbZ_sndfreq,/*sndInt16Little*/sndUInt8,/*sndStereo*/sndStereo,fgbZ_sndCallBack,&reg_sys,512);
			SndStreamStart(snd_stream);		
		}
	}
}


void *sys_timer() {}
int   sys_elapsed(void) {}
void  sys_sleep(int us) {}
void  sys_checkdir(char *path, int wr){}
void  sys_initpath(char *exe){}
void  sys_sanitize(char *s){}


void Cls(int col,int page)
{
	int i;
	uint16 *p=fgbZ_curRenderingScreenPtr;
	for (i=256*240;i;i--)
		*p++=col;
}

void Yo_Printc(uint32 x,uint32 y,char c,uint16 *scr,int col)
{
  int indicex,indicey;  
  uint32 i,j;
  int indice=c-32; //index in the font.h array
  

  if (indice>=96) indice=0;
  if (indice<0) indice=0;
  indicey=(indice>>4)*9;
  indicex=(indice&0xf)<<3;
  
  for (i=0;i<8;i++)
    for (j=0;j<9;j++) if (font[j+indicey][i+indicex]=='#') ((Uint16 *)(scr))[(y+j)*256+(i+x)]=col;
}


void Message (int org_x,int org_y,const char *message,uint16 *buff,int col)
{
  int l;
  int k;
  int msg_x,msg_y;

  
  if (message)
  {
      l=strlen(message);
      msg_x=org_x;
      msg_y=org_y;
      k=0;   
      while (k<l)
	{
	  if (message[k]!='\n') 
	    {
	      Yo_Printc(msg_x,msg_y,message[k],(uint16*)buff,col);
	      msg_x+=6;
	    }
	  else 
	    {
	      msg_y+=8;
	      msg_x=org_x;
	    }
	  if (msg_x>=(256-8))
	    {
	      msg_y+=8;
	      msg_x=0;
	    }
	  if (msg_y>=(144-6))
	    {
	      msg_x=0;
	      msg_y=0;	      
	    }
	  k++;
	}
    }
  
}


/*void DrawMessage(char *msg,int pause)
{
	Cls(0,0);
	Message(0,0,msg,(uint16*)fgbZ_curRenderingScreenPtr,0xFFFF);//do nothing

	TwGfxPointType destLocation = {0, 0};
	TwGfxSurfaceType* displaySurface;
	TwGfxRectType mDisp;
	mDisp.x=0;
	mDisp.y=0;
	mDisp.w=256;
	mDisp.h=144;
	// Get palmos display surface:
	xassert(TwGfxGetPalmDisplaySurface(fgbZ_mGfxLib, &displaySurface));
	destLocation.x=112;
	destLocation.y=40;
	if (!TwGfxIsSurfaceReady(fgbZ_curRenderingScreen))
	{		
		xassert(TwGfxBitBlt(displaySurface, &destLocation, fgbZ_curRenderingScreen, &mDisp));
	}


//pause
	if (pause)
	{
		TwInputHandle mInputQueue;
		Int32 inputFormats[] = { twInputActionA,twInputActionB,twInputActionC,twInputActionD };
		typedef struct {Int32 mBtnA;Int32 mBtnB;Int32 mBtnC;Int32 mBtnD;} ZUserEvent;
		ZUserEvent mUserEvent;
		Int32* mInputFormat;    
    
    	TwInputOpen(&mInputQueue, "twinput", "r");
    	mInputFormat = (Int32*)ljz_malloc(sizeof(Int32)*sizeof(inputFormats)/sizeof(inputFormats[0]));
        memmove(mInputFormat, inputFormats, sizeof(inputFormats));
    	TwInputSetFormat(mInputQueue, mInputFormat, sizeof(inputFormats));
    	TwInputActivate(mInputQueue);

		do{
    		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
	    } while (mUserEvent.mBtnA|mUserEvent.mBtnB|mUserEvent.mBtnC|mUserEvent.mBtnD);
		do{
    		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
	    } while (!(mUserEvent.mBtnA|mUserEvent.mBtnB|mUserEvent.mBtnC|mUserEvent.mBtnD));
	    do{
    		TwInputPoll(mInputQueue, (Int32 *) &mUserEvent, sizeof(mUserEvent));
	    } while (mUserEvent.mBtnA|mUserEvent.mBtnB|mUserEvent.mBtnC|mUserEvent.mBtnD);
	    
	    TwInputClose(mInputQueue);
	    ljz_free(mInputFormat);
	}
}*/
/****************************************************************************/

int fgbZ_ShowMenuGFXConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int scrmode,smoothing,fskipval;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(12*sizeof(RectangleType));
  char tmp[16];
  

	
  if (!fgbZ_renderingmode) {scrmode=0;smoothing=0;}
  else {scrmode=(fgbZ_renderingmode+1)>>1;smoothing=!(fgbZ_renderingmode&1);}
	
  fskipval=fgbZ_frameskip;

	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  
	  	menu_button(10,80,(char*)"FRAMESKIP",0,&item_rect[1],2);	  
	  	menu_bar(200,80,fskipval,11,&item_rect[2]);
	  	if (fskipval<10) sprintf(tmp,"%d",fskipval);
	  	else if (fskipval<AUTO_FSKIP ) sprintf(tmp,"AUTO");
	  	else sprintf(tmp,"Skeezix");
	  	menu_messageRaw(320,80,tmp);
	  
	  	menu_button(10,130,(char*)"SCREENMODE",0,&item_rect[3],2);
	  	menu_button(200,130,(char*)"1:1",(scrmode==0?2:1),&item_rect[4],0);
	  	menu_button(250,130,(char*)"4:3",(scrmode==1?2:1),&item_rect[5],0);
	  	menu_button(300,130,(char*)"FULL",(scrmode==2?2:1),&item_rect[6],0);
	  	menu_button(350,130,(char*)"ZOOM",(scrmode==3?2:1),&item_rect[7],1);
	  
	  	menu_button(10,180,(char*)"SMOOTHING",0,&item_rect[8],2);
	  	menu_button(200,180,(char*)"OFF",(smoothing?1:2),&item_rect[9],0);
	  	menu_button(250,180,(char*)"ON",(smoothing?2:1),&item_rect[10],0);	  	  	  
	  	
	  	if (scr) WinScreenUnlock();
	
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //FSKIP
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
	  	fskipval=(x-10-item_rect[2].topLeft.x)*11/100;
	  	if (fskipval<0) fskipval=0;
	  	if (fskipval>11) fskipval=11;
	  	redraw=1;
	  }
	  //SCREEN MODES
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
	  	  scrmode=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
	  	  scrmode=1;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	  scrmode=2;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	  scrmode=3;
	  	  redraw=1;
	  }
	  //SMOOTHING
	  if (TEST_PEN_MENU(x,y,item_rect[9])&&scrmode) 
	  {
	  	  smoothing=0;
	  	  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])&&scrmode) 
	  {
	  	  smoothing=1;
	  	  redraw=1;
	  }
  }  
  
  fgbZ_frameskip=fskipval;

  if (!scrmode) fgbZ_renderingmode=0;
	else 
	if (scrmode==1) fgbZ_renderingmode=(smoothing?2:1);
	else
	if (scrmode==2) fgbZ_renderingmode=(smoothing?4:3);
	else
	fgbZ_renderingmode=(smoothing?6:5);
	
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}



int fgbZ_ShowMenuSNDConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  int vol;
  int bassboost;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  vol=TwSndGetVolume();
  bassboost=TwSndGetBassBoost();
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"SOUND",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(fgbZ_enabledSound==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SIM",(fgbZ_enabledSound==1?2:1),&item_rect[3],0);	  
	  menu_button(300,80,(char*)"ON",(fgbZ_enabledSound==2?2:1),&item_rect[4],0);	 
	  
/*	  menu_button(10,120,(char*)"VOLUME",0,&item_rect[5],2);	  
	  menu_bar(200,120,vol,64,&item_rect[6]);
	  sprintf(tmp,"%d%",vol*100/64);	  	
	  	menu_messageRaw(320,120,tmp);*/
	  
	  menu_button(10,120,(char*)"BASS BOOST",0,&item_rect[7],2);
	  menu_button(200,120,(char*)"OFF",(bassboost==0?2:1),&item_rect[8],0);
	  menu_button(300,120,(char*)"ON",(bassboost?2:1),&item_rect[9],0);	 
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //SOUND OFF
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  fgbZ_enabledSound=0;		  
		  redraw=1;
	  }
	  //SOUND SIM
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
	  	  fgbZ_enabledSound=1;	  	  
	  	  redraw=1;
	  }
	  //SOUND ON
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  fgbZ_enabledSound=2;
		  redraw=1;
	  }
	  
	  //VOLUME
/*	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	vol=(x-item_rect[6].topLeft.x)*64/100;
	  	if (vol>64) vol=64;
	  	redraw=1;
	  }*/
	  //BASSBOOST OFF
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	bassboost=0;
	  	redraw=1;
	  }
	  //BASSBOOST ON
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	bassboost=1;
	  	redraw=1;
	  }
  }  
  
  TwSndSetVolume(vol);
  TwSndSetBassBoost(bassboost);
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}


int fgbZ_ShowMenuOTHERConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  char tmp[16];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr) memcpy(scr,savescr,480*320*2);	    
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(10,80,(char*)"AUTOFIRE A",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"OFF",(fgbZ_autofireA==0?2:1),&item_rect[2],0);
	  menu_button(250,80,(char*)"SLW",(fgbZ_autofireA==1?2:1),&item_rect[3],0);
	  menu_button(300,80,(char*)"MED",(fgbZ_autofireA==2?2:1),&item_rect[4],0);
	  menu_button(350,80,(char*)"FST",(fgbZ_autofireA==3?2:1),&item_rect[5],0);
	  
	  menu_button(10,120,(char*)"AUTOFIRE B",0,&item_rect[6],2);
	  menu_button(200,120,(char*)"OFF",(fgbZ_autofireB==0?2:1),&item_rect[7],0);
	  menu_button(250,120,(char*)"SLW",(fgbZ_autofireB==1?2:1),&item_rect[8],0);
	  menu_button(300,120,(char*)"MED",(fgbZ_autofireB==2?2:1),&item_rect[9],0);
	  menu_button(350,120,(char*)"FST",(fgbZ_autofireB==3?2:1),&item_rect[10],0);
	  
	  menu_button(10,160,(char*)"EMU SPEED",0,&item_rect[11],2);	  
	  menu_bar(200,160,fgbZ_speedpct,100,&item_rect[12]);
	  sprintf(tmp,"%d%",fgbZ_speedpct);
    	menu_messageRaw(320,160,tmp);
	  
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,0);
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //AUTOFIRE A
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
		  fgbZ_autofireA=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  fgbZ_autofireA=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[4])) 
	  {
		  fgbZ_autofireA=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[5])) 
	  {
		  fgbZ_autofireA=3;
		  redraw=1;
	  }
	  //AUTOFIRE B
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
		  fgbZ_autofireB=0;		  
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
		  fgbZ_autofireB=1;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
		  fgbZ_autofireB=2;
		  redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[10])) 
	  {
		  fgbZ_autofireB=3;
		  redraw=1;
	  }
	  //SPEED
	  if (TEST_PEN_MENU(x,y,item_rect[12])) 
	  {
	  	fgbZ_speedpct=(x-10-item_rect[12].topLeft.x);
	  	if (fgbZ_speedpct>100) fgbZ_speedpct=100;
	  	if (fgbZ_speedpct<10) fgbZ_speedpct=10;
	  	redraw=1;
	  }
  }  
  
  menu_waitPen(NULL,NULL,2);
  
  ljz_free(item_rect);
  return result;
}




int fgbZ_ShowMenuSave(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  FILE *savefile;
  	  int slot[4];
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
  	  for (int i=0;i<4;i++) 
  	  	if (state_load(i,1))   	  	
  	  	{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			GetStateFileName(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);
			//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
	  	}	  	  	
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"SAVE",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:1),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:1),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:1),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:1),&item_rect[5],1);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //SAVE 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (!slot[1]||(menu_confirm("Overwrite ?")))
		  {state_save(1);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (!slot[2]||(menu_confirm("Overwrite ?")))
		  {state_save(2);result=1; break;}
		  else redraw=1;
		 
	  }
	  //SAVE 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (!slot[3]||(menu_confirm("Overwrite ?")))
		  {state_save(3);result=1; break;}
		  else redraw=1;
		 
	  }
	  //QUICKSAVE
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
		  if (!slot[0]||(menu_confirm("Overwrite ?")))
		  {state_save(0);result=1; break;}
		  else redraw=1;
		 
	  }
  }  
  ljz_free(item_rect);
  return result;
}



int fgbZ_ShowMenuLoad(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
   int slot[4];
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
  memset((char*)item_rect,0,15*sizeof(RectangleType));
  
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  	  FILE *savefile;
  	 
  	  slot[0]=slot[1]=slot[2]=slot[3]=0;
      for (int i=0;i<4;i++) 
      	if (state_load(i,1)) 
      	{
      		slot[i]=1;
      
	  		struct tm *localTime;
			time_t long_time;
			char str[255];		
			GetStateFileName(i,str);
			long_time=__getdate_file(str);		
			localTime = localtime(&long_time);
			//date is an ofs from 01 Jan 1900 00:00:00			
			sprintf(str,"%02d %s %02d %02d:%02d",
			localTime->tm_mday,str_month[localTime->tm_mon],localTime->tm_year-100,localTime->tm_hour,localTime->tm_min);
			if (i) 
			{
				menu_messageRaw(300,50+i*30,str);
				menu_button(160,50+i*30,"X",5,&item_rect[6+i],3);
			}
			else 
			{
				menu_messageRaw(300,170,str);
				menu_button(160,170,"X",5,&item_rect[6+i],3);
			}
	  	}	
      
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
	  menu_button(10,80,(char*)"LOAD",0,&item_rect[1],2);
	  menu_button(200,80,(char*)"SLOT 1",(slot[1]?2:3),&item_rect[2],1);
	  menu_button(200,110,(char*)"SLOT 2",(slot[2]?2:3),&item_rect[3],1);
	  menu_button(200,140,(char*)"SLOT 3",(slot[3]?2:3),&item_rect[4],1);
	  menu_button(200,170,(char*)"QUICK",(slot[0]?2:3),&item_rect[5],1);
		if (scr) WinScreenUnlock();	  
  	  }
	  menu_waitPen(&x,&y,1);

  	  if (TEST_PEN_MENU(x,y,item_rect[6])) 
	  {
	  	if (menu_confirm("Delete QUICKSLOT?"))
	  	{
		  	char str[255];		
			GetStateFileName(0,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[7])) 
	  {
	  	if (menu_confirm("Delete SLOT 1?"))
	  	{
		  	char str[255];		
			GetStateFileName(1,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[8])) 
	  {
	  	if (menu_confirm("Delete SLOT 2?"))
	  	{
		  	char str[255];		
			GetStateFileName(2,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  if (TEST_PEN_MENU(x,y,item_rect[9])) 
	  {
	  	if (menu_confirm("Delete SLOT 3?"))
	  	{
		  	char str[255];		
			GetStateFileName(3,str);
	  		remove(str);
	  	}
	  	redraw=1;
	  }
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //LOAD 0
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  if (slot[1])
		if (state_load(1,0)) {result=1;break;}
	  }
	  //LOAD 1
	  if (TEST_PEN_MENU(x,y,item_rect[3]))
	  {
		  if (slot[2])
		if (state_load(2,0)) {result=1;break;}
	  }
	  //LOAD 2
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot[3])
		if (state_load(3,0)) {result=1;break;}	  
	  }
	
	  //QUICKLOAD
	  if (TEST_PEN_MENU(x,y,item_rect[5]))
	  {
	  	if (slot[0])
    	if (state_load(0,0)) {result=1;break;}
	  }
  }  
  ljz_free(item_rect);
  return result;
}


int fgbZ_ShowMenuConfig(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  	
  		
  	  	  	  	  	  	
	  menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);	  
	  menu_button(172,100,(char*)"GFX",0,&item_rect[1],2);
	  menu_button(172,150,(char*)"SOUND",0,&item_rect[2],2);
	  menu_button(172,200,(char*)"OTHER",0,&item_rect[3],2);
	  menu_button(172,250,(char*)"SND & BRT",9,&item_rect[4],2);
	  if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}	  
	  //GFX
	  if (TEST_PEN_MENU(x,y,item_rect[1])) 
	  {
	  	fgbZ_ShowMenuGFXConfig(savescr);
		redraw=1;
	  }
	  //SOUND
	  if (TEST_PEN_MENU(x,y,item_rect[2])) 
	  {
     	fgbZ_ShowMenuSNDConfig(savescr);
		redraw=1;
	  }
	  //OTHER
	  if (TEST_PEN_MENU(x,y,item_rect[3])) 
	  {
		  fgbZ_ShowMenuOTHERConfig(savescr);
		  redraw=1;		  
	  }
	  //SND & BRT
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
	  	  EventType myevent;
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,0);
	  	  	  if (myevent.eType==nilEvent) break;			  
		  }
	  	  
	  	  myevent.eType=keyDownEvent;
	  	  myevent.data.keyDown.chr=vchrBrightness;	  	  
	  	  EvtAddEventToQueue(&myevent);
	  	  
	  	  for (;;)	  	  
	  	  {
		  	  EvtGetEvent(&myevent,100);
	  	  	  if (myevent.eType==nilEvent) break;
			  if (myevent.eType==keyDownEvent)
			  {
			  	if (myevent.data.keyDown.chr!=vchrLaunch)
			  	{SysHandleEvent(&myevent);}
			  }			  
		  }
		  redraw=1;
	  }
  }  
  ljz_free(item_rect);
  return result;
}

int fgbZ_ShowSysInfos(uint8 *savescr)
{
  uint8 *scr;
  int x,y;
  int redraw;  
  int result;
  RectangleType *item_rect,my_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));
	    
  redraw=1;         
  for (;;)
  {  
  	  if (redraw)
  	  {
  	  	redraw=0;
  	  	scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
		//if (scr) WinScreenUnlock();
  	  	RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
				
		char str[64],strb[32];
		unsigned long maxP,freeP,usedP;		
		VolumeInfoType vinfo;
		VFSVolumeSize(fgbZ_curVolume,&usedP,&maxP);		
		VFSVolumeGetLabel(fgbZ_curVolume,strb,16);strb[16]=0;
		menu_button(10,70,"Volume",0,&my_rect,4);		
		sprintf(str,"%s[%d] Used:%dMb/%dMb",strb,fgbZ_curVolume,usedP>>20,maxP>>20);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,70,str);				
		MemHeapFreeBytes(0,&freeP,&maxP);		
		menu_button(10,100,"RAM",6,&my_rect,4);		
		sprintf(str,"RAM Free:%d Max:%d",freeP,maxP);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,100,str);		
		TwGfxInfoType gfxinfo;
		gfxinfo.size=sizeof(gfxinfo);
		TwGfxGetInfo(fgbZ_mGfxLib,&gfxinfo);		
		menu_button(10,130,"VRAM",6,&my_rect,4);		
		sprintf(str,"Free:%d Max:%d",gfxinfo.freeAcceleratorMemory,gfxinfo.totalAcceleratorMemory);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,130,str);
						
    		
		menu_button(10,160,"ROM",4,&my_rect,4);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,160,rom.name);
		
		sprintf(str,"%dKo RAM-%dKo",mbc.romsize,mbc.ramsize);
		menu_button(10,190,"Size",4,&my_rect,4);
	    menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,190,str);
	    
		menu_button(10,220,"Type",7,&my_rect,4);		
		sprintf(str,"%d Batt:%d Rtc:%d CGB:%d",mbc.type,mbc.batt,rtc.batt,hw.cgb);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,220,str);
		
		menu_button(10,250,"CRC",7,&my_rect,4);		
		sprintf(str,"%08X",fgbZ_romCrc);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,250,str);
		
		menu_button(10,280,"GoodGB",7,&my_rect,4);		
		int i=DAT_LookFor(fgbZ_romCrc);
		if (i<0) sprintf(str,"not found");
		else sprintf(str,"%s",MyDat[i].name);
		menu_messageRaw(my_rect.topLeft.x+my_rect.extent.x+5,280,str);
		
						  	
	  	menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		
	  
	  	if (scr) WinScreenUnlock();
  	  }
	  menu_waitPen(&x,&y,1);
	  
	  
	  
	  //BACK	  
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  
	  
  }  
  ljz_free(item_rect);
  return result;
}


int fgbZ_ShowMenu()
{
  int x,y;
  int redraw;
  int result;
  int slot0;
  uint8 *scr,*savescr;
  RectangleType *item_rect;
  item_rect=(RectangleType*)ljz_malloc(15*sizeof(RectangleType));  
  redraw=1;
  
  fgbZ_pause(1);
    
  
   TwGfxSurfaceType* displaySurface;
  // Get palmos display surface:
  xassert(TwGfxGetPalmDisplaySurface(fgbZ_mGfxLib, &displaySurface));
  while (TwGfxIsSurfaceReady(displaySurface));

  
  savescr=(uint8*)ljz_malloc(320*480*2);  
  scr=WinScreenLock(winLockCopy);  
  if (scr&&savescr)
  {
	  for (x=0;x<320*480;x++)
	  {
  		y=((uint16*)scr)[x];
	  	((uint16*)scr)[x]=((y>>12)<<11)|(((y>>6)&31)<<5)|((y>>1)&15);
	  }
	  memcpy(savescr,scr,480*320*2);
  }
  if (scr) WinScreenUnlock();
            
              
  for (;;)
  {  
  	if (redraw)
  	{  	
	  	slot0=state_load(0,1);    
  		redraw=0;
		scr=WinScreenLock(winLockCopy);  
	    if (scr&&savescr) memcpy(scr,savescr,480*320*2);	    
//		if (scr) WinScreenUnlock();
  		
  		RGBColorType fg;
	  	WinPushDrawState ();
  	  	WinSetDrawMode(winOverlay);
    	fg.r=50;fg.g=200;fg.b=50;
	    WinSetTextColorRGB(&fg,NULL);
	    WinSetForeColorRGB(&fg,NULL);
	    FntSetFont(boldFont);
		WinPaintChars(LJZ_OSD_TITLE,strlen(LJZ_OSD_TITLE),10,10);	
		WinPopDrawState();
  		
		menu_button(310,20,(char*)"BACK",6,&item_rect[0],2);
		menu_button(60,100,(char*)"SAVE",0,&item_rect[1],2);
		menu_button(280,100,(char*)"QUICK SAVE",(slot0?2:1),&item_rect[2],2);
		menu_button(60,150,(char*)"LOAD",0,&item_rect[3],2);
		menu_button(280,150,(char*)"QUICK LOAD",(slot0?2:3),&item_rect[4],2);
		menu_button(60,200,(char*)"CONFIG",0,&item_rect[5],2);
		menu_button(280,250,(char*)"LAUNCHER",4,&item_rect[6],2);
		
		menu_button(280,200,(char*)"SYS INFOS",7,&item_rect[8],2);
		
		menu_button(60,250,(char*)"RESET GB",9,&item_rect[7],2);				
		if (scr) WinScreenUnlock();		
		
  	}
	  menu_waitPen(&x,&y,1);
	  //HOME
	  if (TEST_PEN_MENU(x,y,item_rect[6])) {result=1;break;}
	  //BACK
	  if (TEST_PEN_MENU(x,y,item_rect[0])) {result=0;break;}
	  //CONFIG
	  if (TEST_PEN_MENU(x,y,item_rect[5])) {fgbZ_ShowMenuConfig(savescr);redraw=1;}
	  //LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[3])) {if (fgbZ_ShowMenuLoad(savescr)) {result=0;break;} redraw=1;}
	  //SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[1])) {if (fgbZ_ShowMenuSave(savescr)) {result=0;break;} redraw=1;}
	  //QUICK SAVE
	  if (TEST_PEN_MENU(x,y,item_rect[2]))
	  {
		  state_save(0);
		  result=0;
		  break;
	  }
	  //QUICK LOAD
	  if (TEST_PEN_MENU(x,y,item_rect[4]))
	  {
		  if (slot0)
	    if (state_load(0,0)) {result=0;break;}
	  }
	  //RESET GB
	  if (TEST_PEN_MENU(x,y,item_rect[7])) {if (menu_confirm("Reset GB ?")) {emu_reset(); result=0;break;}redraw=1;}
	  
	  //SYS INFOS
	  if (TEST_PEN_MENU(x,y,item_rect[8])) {fgbZ_ShowSysInfos(savescr);redraw=1;}

	}
  ljz_free(item_rect);
  
  ljz_free(savescr);
            
  fgbZ_pause(0);
  return result;
}  



