
#include "PicoInt.h"

int PicoVer=0x0011;
struct Pico Pico;
int PicoPad[2]; // Joypads, format is SACB RLDU

int PicoInit()
{
  // Blank space for state:
  memset(&Pico,0,sizeof(Pico));
  memset(&PicoPad,0,sizeof(PicoPad));

  // Init CPU:
  SekInit();

  // Setup memory callbacks:
  PicoMemInit();
  return 0;
}

void PicoExit()
{
  memset(&Pico,0,sizeof(struct Pico));
}

int PicoFrame()
{
  int total=0;
  
  if (Pico.rom==NULL) return 1; // No Rom plugged in

  // V-Blanking period:
  if (Pico.video.reg[1]&0x20) SekInterrupt(6); // Set IRQ
  Pico.video.status|=0x88; // V-Int happened / go into vblank
  total+=SekRun(18560);

  // Active Scan:
  if (Pico.video.reg[1]&0x40) Pico.video.status&=~8; // Come out of vblank if display is enabled
  SekInterrupt(0); // Clear IRQ
  total+=SekRun(127969-total);

  PicoDraw();

  return 0;
}

int PicoReset()
{
  SekReset();
  return 0;
}
