
#include "shared.h"

uint32 yo_align_arm3_;
static uint8 block[0x4000];
uint32 rom_size;

void deinterleave_block(uint8 *src,uint32 ofs)
{
    int i;
    uint8 *tmpbl=(uint8*)ljz_malloc(0x4000);
    memcpy(block, src+ofs, 0x4000);
    for(i = 0; i < 0x2000; i += 1)
    {
        tmpbl[i*2+0] = block[0x2000 + (i)];
        tmpbl[i*2+1] = block[0x0000 + (i)];
    }
    if (DmWrite(src,ofs,tmpbl,0x4000))
	{menu_message("Error while dmwriting 1");menu_waitPen(NULL,NULL,1);}
    ljz_free(tmpbl);
}

int load_rom(char *filename)
{
    int size, offset = 0;
    uint8 *header;//[0x200];

    //memset(cart_rom, 0, 0x400000);
    //not a pb if we go further than 0x400000 -> we reach work_ram...
    //=(uint8*)ljz_malloc(0x400000);
    
    //try to use storage instead of heap mem	
	FtrPtrNew(APPLI_ID, FTR_ROM_ID, 0x400000 + 0x200 , (void **)&cart_rom);	
    
    if(!load_archive(filename, &size,cart_rom)) return (0);
    
    header=ljz_malloc(0x200);

    if((size&0x3fff)==0x200/*(size / 512) & 1*/)
    {
        int i;

        size -= 512;
        offset += 512;

        memcpy(header, cart_rom, 512);

        for(i = 0; i < (size / 0x4000); i += 1)
        {
            deinterleave_block(cart_rom,offset + (i * 0x4000));
        }            
    }
        
    if(size > 0x400000) size = 0x400000;
    //memcpy(cart_rom, ptr + offset, size);
    if (offset)
    {
//    	menu_confirm("offset");
	    //for (int i=0;i<size;i++)
//    	{
    		//cart_rom[i]=cart_rom[i+offset];
    		if (DmWrite(cart_rom,0,cart_rom+0+offset,size))
			{menu_message("Error while dmwriting 2");menu_waitPen(NULL,NULL,1);}
//	    }
	}
    
    ljz_free(header);
    /* Free allocated file data */            
    //ljz_free(ptr);        
    rom_size=size;
    
    
        /*SRAM*/    
    if(cart_rom[0x1b1] == 'A' && cart_rom[0x1b0] == 'R')
    {
      save_start = cart_rom[0x1b4] << 24 | cart_rom[0x1b5] << 16 | 
                   cart_rom[0x1b6] << 8  | cart_rom[0x1b7] << 0;
      save_len = cart_rom[0x1b8] << 24 | cart_rom[0x1b9] << 16 |
  	         cart_rom[0x1ba] << 8  | cart_rom[0x1bb] << 0;
      // Make sure start is even, end is odd, for alignment
// A ROM that I came across had the start and end bytes of
// the save ram the same and wouldn't work.  Fix this as seen
// fit, I know it could probably use some work. [PKH]
      if(save_start != save_len) 
      {
        if(save_start & 1) --save_start;
        if(!(save_len & 1)) ++save_len;
        save_len -= (save_start - 1);
        saveram = (unsigned char*)ljz_malloc(save_len);
		// If save RAM does not overlap main ROM, set it active by default since
		// a few games can't manage to properly switch it on/off.
		if(save_start >= rom_size)
			  save_active = 1;
      }
      else 
      {
        save_start = save_len = 0;
        saveram = NULL;
      }
    }
  	else
    {
      save_start = save_len = 0;
      saveram = NULL;
    }
    
    
    return (1);
}



