#ifndef __ljz_std_h__
#define __ljz_std_h__

#include <TapWave.h>

#define LJZ_STD_DEBUG
#define LJZ_STD_ERROR_VERBOSE
#define LJZ_ZLIB


#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif


#include "LJZmenu.h"

void *ljz_malloc(int size);
void *ljz_calloc(int num_elt,int size_elt);
void ljz_free(void *ptr);

void ljz_std_showstat(void);

void ljz_cls(TwGfxType *mGfxLib,UInt32 col);

#ifdef LJZ_ZLIB
#include "zlib.h"
#define STREAM gzFile
#define READ_STREAM(p,l,s) gzread (s,p,l)
#define WRITE_STREAM(p,l,s) gzwrite (s,p,l)
#define OPEN_STREAM(f,m) gzopen (f,m)
#define CLOSE_STREAM(s) gzclose (s)
#define SEEK_STREAM(p,r,s) gzseek(s,p,r)
#endif


#if defined(__cplusplus) || defined(c_plusplus)
}
#endif


#define LJZ_HANDLE_SYS_EVENT(cond,pause_func) \
		{if (cond) \
			{ \
				EventType myevent; \
				for (;;) \
				{ \
					EvtGetEvent(&myevent,0); \
					if (myevent.eType==nilEvent) break; \
					switch (myevent.eType) \
					{				 \
						case penDownEvent: \
						case penUpEvent: \
						case penMoveEvent: \
						case keyDownEvent: \
						case appStopEvent: \
						case frmUpdateEvent: \
						case winExitEvent: \
						case winEnterEvent: \
						break; \
						default: \
						{	 \
							pause_func(1); \
							WinPushDrawState(); \
							SysHandleEvent(&myevent); \
							WinPopDrawState(); \
							pause_func(0); \
						} \
					} \
				  } \
			}\
		}


#endif

#define LJZ_SHOW_SND_BRT {\
		EventType myevent;\
	  	  \
	  	  for (;;)	  	  \
	  	  {\
		  	  EvtGetEvent(&myevent,0);\
	  	  	  if (myevent.eType==nilEvent) break;			  \
		  }\
	  	  \
	  	  myevent.eType=keyDownEvent;\
	  	  myevent.data.keyDown.chr=vchrBrightness;	  	  \
	  	  EvtAddEventToQueue(&myevent);\
	  	  \
	  	  for (;;)	  	  \
	  	  {\
		  	  EvtGetEvent(&myevent,1000);\
	  	  	  if (myevent.eType==nilEvent) break;\
			  if (myevent.eType==keyDownEvent)\
			  {\
			  	if (myevent.data.keyDown.chr!=vchrLaunch)\
			  	{SysHandleEvent(&myevent);}\
			  }			  \
		  }}
		  