#include "datatypes.h"
#include "unes_mapper.h"
#include "unes.h"

extern int32 num_1k_VROM_banks;
extern int32 num_8k_ROM_banks;

static uint8 irq_enabled;
/////////////////////////////////////////////////////////////////////
// Mapper 50
static void map50_Reset()
{
	set_CPU_banks(15,8,9,0,11);
	set_PPU_banks(0,1,2,3,4,5,6,7);

	irq_enabled = 0;
}

static void map50_MemoryWriteLow(uint32 addr, uint8 data)
{
	if((addr & 0xE060) == 0x4020)
	{
		if(addr & 0x0100)
		{
			irq_enabled = data & 0x01;
		}
		else
		{
			set_CPU_bank6((data&0x08)|((data&0x01)<<2)|((data&0x06)>>1));
		}
	}
}

static void map50_HSync(uint32 scanline)
{
	if(irq_enabled)
	{
		if(scanline == 21)
		{
			parent_NES->cpu->DoIRQ();
		}
	}
}
/////////////////////////////////////////////////////////////////////

mapintf_t map50_intf =
{
   50, /* mapper number */
   "map50", /* mapper name */
   map50_Reset, /* init routine */
   NULL, /* vblank callback */
   map50_HSync, /* hblank callback */
   map50_getstate, /* get state (snss) */
   map50_setstate, /* set state (snss) */
   NULL,  /*Read low*/
   NULL,  /*Read saveram or rom*/
   NULL,  /*Write high regs 0x4000-0x4017*/
   map50_MemoryWriteLow,  /*Write low   0x4018-0x5FFF*/
   NULL,  /*Write saveram*/
   NULL,  /*Write rom*/
   NULL,   /*Latch FDFE*/
   NULL,   /*Latch renderscreen*/
   NULL,   /*Latch Address*/
   NULL    /*SetBarcodeValue*/   
};
