//---------------------------------------------------------------------------
// NEOPOP : Emulator as in Dreamland
//
// Copyright (c) 2001-2002 by neopop_uk
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//	This program is free software; you can redistribute it and/or modify
//	it under the terms of the GNU General Public License as published by
//	the Free Software Foundation; either version 2 of the License, or
//	(at your option) any later version. See also the license.txt file for
//	additional informations.
//---------------------------------------------------------------------------

/*
//---------------------------------------------------------------------------
//=========================================================================

	system_main.h

//=========================================================================
//---------------------------------------------------------------------------

  History of changes:
  ===================

21 JUL 2002 - neopop_uk
=======================================
- This include file is for 'system_main.c' functions only

26 JUL 2002 - neopop_uk
=======================================
- Made the menu external for 'unload rom'

22 AUG 2002 - neopop_uk
=======================================
- Moved NEOPOP_WIN32_VERSION here for more importance.

27 AUG 2002 - neopop_uk
=======================================
- Added "BOOL windowed"
  
28 AUG 2002 - neopop_uk
=======================================
- Made the keyboard accelerator global for external message pumps.
- Added 'set paused' function so comms can pause things.

//---------------------------------------------------------------------------
*/

#ifndef __SYSTEM_MAIN__
#define __SYSTEM_MAIN__
//=============================================================================

#define NEOPOP_ZODIAC_VERSION	"ZODIAC/LJZ v0.3"

#include "TapWave.h"

#include "LJZmenu.h"


#define NEOPOPZ_TURBOFSKIP 15
#define NEOPOPZ_ROMSDIR "0:/PALM/Programs/LJZ/NGP/Roms/"
#define NEOPOPZ_SAVESDIR "0:/PALM/Programs/LJZ/NGP/Saves/"
#define AUTO_FSKIP 10
#define SKEEZIX_FSKIP 11

#define MAX_FRAME_SKIPPED 10

#define KEY_UP    	0x00000001
#define KEY_DOWN  	0x00000002
#define KEY_LEFT  	0x00000004
#define KEY_RIGHT 	0x00000008
#define KEY_SEL   	0x00000010
#define KEY_A     	0x00000020
#define KEY_B	  	0x00000040
#define KEY_START	0x00000080
#define KEY_QUICKLOAD   0x00000100
#define KEY_QUICKSAVE   0x00000200
#define KEY_TURBO  	0x00000400
#define KEY_SCREENMODE	0x00000800
#define KEY_FRAMESKIP	0x00001000

// Assertion Support
static void
assert_check(int error, const char* message)
{
    if (error) {
        ErrDisplayFileLineMsg("PalmOS", (UInt16) error, message);
    }
}

#define xassert(error) {assert_check(error, #error);}

static void showError(const char* aWhat, Err aError) {
    ErrDisplayFileLineMsg("oink", (UInt16) aError, aWhat);
}



//=============================================================================
#endif
