
#ifndef __TLCS900H_
#define __TLCS900H_
//=============================================================================

//Interprets a single instruction from '_pc', 
//_pc is incremented to the start of the next instruction.
//Returns the number of cycles taken for this instruction
_u8 TLCS900h_interpret(void);

//=============================================================================
//ThunderZ -> a mettre dans bioshle.c
//void iBIOSHLE(reg)
//{
//	tw*rg = &tlcs;

// POKE
typedef struct
{
	_u8* 	_ipc;			//Quick CPU fetching
	_u16	status;			// SR Status register
	_u8 	opcode1;		//First opcode
	_u8		statusRFP;		//main registers selector
	_u8 	opcode2;		//Second opcode
	_u8 	regsel;			//(second&7) register (ADRESS)
	_u8 	timer;			//approx. timer
	_u32 	memadr;			//memory access adress
	int 	argsize;		//1Byte/2word/3dword
	_u8 	slot;			//Local CPU memory
	BOOL 	regvector;		//Row register select
	_u32 	_ipcr;			//CPU absolute address (from tlcs._ipc)
	//_u32*	halfBank[8];		
	//_u32	gpr[4];

	_u8		index[32];
	_u32 	gprBank[6][4];
	_u8 	rptrBtrans[8];
	
	
							// A FAIRE !
//	_u8		swr;			//Switch actuel sur gnraux (16/32/48/64) 0 tant XIX/XIY/XIZ/XSP
//	_u8		regs[(4+(4*4))*4];	//Quatres registres gnraux XIX/XIY/XIZ/XSP
							//+ Tous les data registres (4banques de 4 registres 32 bits)
							//XWA,XBC,XDE,XHL *4 banks
}tw;

extern tw tlcs;
//extern _u16	(rg->status);

#define sr2 (tlcs.status)


//=============================================================================

void instruction_error(char* vaMessage,...);

//=============================================================================
//#define FETCH8		(*mainpc_addr++);loadB(_pc++)
//#define FETCH8	((_pc<=RAM_END)?ram[_pc++]&0xFF:loadB(_pc++))
//#define FETCH8	((_pc<=RAM_END)?0:loadB(_pc++))

#include "mem.h"

# define mov_pc(rg,a) rg->_ipc+=a
# define get_pc(rg) ((_u32)(rg->_ipcr+rg->_ipc))

__inline void set_pc( tw*rg,_u32 a) 
{
  	rg->_ipc =(_u8*) translate_address_read(a);
	rg->_ipcr=a-(_u32)rg->_ipc;
}


#define FETCH8		(*rg->_ipc++)
//loadB(ipc++)

__inline _u16 fetch16(tw*rg)
{
  //_u8* ptr =(_u8*) translate_address_read(ipc+2);
  rg->_ipc+=2;
  // return *(_u16*)(_u8*)(rg->_ipc-2);
  return rg->_ipc[-2]|(rg->_ipc[-1]<<8);
}

__inline _u32 fetch24(tw*rg)
{
//  _u8* ptr =(_u8*) translate_address_read(ipc+3);
  rg->_ipc+=3;
  //return (_u16*)(_u8*)rg->_ipc[-2]);
  return rg->_ipc[-3]|(rg->_ipc[-2]<<8)|(rg->_ipc[-1]<<16);
}

__inline _u32 fetch32(tw*rg)
{
  //_u8* ptr =(_u8*) translate_address_read(ipc+4);
  rg->_ipc+=4;
  return rg->_ipc[-4]|(rg->_ipc[-3]<<8)|(rg->_ipc[-2]<<16)|(rg->_ipc[-1]<<24);
  //return *(_u32*)(_u8*)(rg->_ipc-4);

}

//=============================================================================

void parityB(tw*rg,_u8 value);
void parityW(tw*rg,_u16 value);

//=============================================================================

/*
void push8(_u8 data);
void push16(_u16 data);
void push32(_u32 data);

_u8 pop8(tw*rg);
_u16 pop16(tw*rg);
_u32 pop32(tw*rg);
*/
//=============================================================================

void reset_registers(tw*rg);
void dump_registers_TLCS900h(tw*rg);

//The value read by bad rCodes, leave 0, improves "Gals Fighters"
#define RERR_VALUE		0

//=============================================================================

extern _u8 f_dash;

//extern _u32 gprBank[4][4], gpr[4];

extern _u32 rErr;

//extern _u8 statusRFP;

//GPR Access

//#define regB(x)	(rg->halfBank[0][rg->rptrBtrans[(x)]])
//#define regW(x)	(rg->halfBank[x>>2][x&3])
//#define regL(x)	(rg->halfBank[x>>2][x&3])

//#define regB(x)	(*(rg->gprMapB[rg->statusRFP][(x)]))

/*
#define regB(x)	(*(((_u8*)(rg->halfBank[0]))+rg->rptrBtrans[(x)]))
#define regW(x)	(*((_u16*)(rg->halfBank[x])))
#define regL(x)	(*((_u32*)(rg->halfBank[x])))
*/

#define bankof(x) (((_u8*)&rg->gprBank)+x)
#define regB(x)	(*(_u8*) bankof((rg->statusRFP<<4)+rg->rptrBtrans[x&0x7]))
//#define regB(x)	(*(_u8*)bankof(rg->rptrBtrans[x&0xF]))
#define regW(x)	(*(_u16*)bankof(rg->index[0x18+(x&0xF)]))
#define regL(x)	(*(_u32*)bankof(rg->index[0x18+(x&0xF)]))

#define regB0 regB(0)
#define regB1 regB(1)
#define regB2 regB(2)
#define regB3 regB(3)
#define regB4 regB(4)
#define regB5 regB(5)
#define regB6 regB(6)
#define regB7 regB(7)

//#define regadrL(x) ((_u32*)(&rg->halfBank[0][x]))

#define regW0 regW(0)
#define regW1 regW(1)
#define regW2 regW(2)
#define regW3 regW(3)
#define regW4 (*(_u16*)(_u8*)bankof(0x40))
#define regW5 (*(_u16*)(_u8*)bankof(0x44))
#define regW6 (*(_u16*)(_u8*)bankof(0x48))
#define regW7 (*(_u16*)(_u8*)bankof(0x4C))

#define regL0 regL(0)
#define regL1 regL(1)
#define regL2 regL(2)
#define regL3 regL(3)
#define regL4 (*(_u32*)(_u8*)bankof(0x40))
#define regL5 (*(_u32*)(_u8*)bankof(0x44))
#define regL6 (*(_u32*)(_u8*)bankof(0x48))
#define regL7 (*(_u32*)(_u8*)bankof(0x4C))

//Reg.Code Access
/*extern _u8*  regCodeMapB[4][256];
extern _u16* regCodeMapW[4][128];
extern _u32* regCodeMapL[4][64];
*/

#define rCodeB(r)	(*bankof(rg->index[(r>>2)&0x1C]+(r&0xF)))
#define rCodeW(r)	(*(_u16*)(_u8*)bankof(rg->index[(r>>2)&0x1C]+(r&0xE)))
#define rCodeL(r)	(*(_u32*)(_u8*)bankof(rg->index[(r>>2)&0x1C]+(r&0xC)))

//#define rCodeB(r)	(*(rg->regCodeMapB[rg->statusRFP][(r)]))
//#define rCodeW(r)	(*(rg->regCodeMapW[rg->statusRFP][(r) >> 1]))
//#define rCodeL(r)	(*(rg->regCodeMapL[rg->statusRFP][(r) >> 2]))

//Common Registers
#define REGA		(regB(1))
#define REGWA		(regW(0))
#define REGBC		(regW(1))
#define REGXSP		(regL7)

//=============================================================================

__inline void push8(tw*rg,_u8 data)  { REGXSP -= 1;  storeB(REGXSP, data);}
__inline void push16(tw*rg,_u16 data)  { REGXSP -= 2;  storeW(REGXSP, data);}
__inline void push32(tw*rg,_u32 data)  { REGXSP -= 4;  storeL(REGXSP, data);}

__inline _u8 pop8(tw*rg)   {  _u8 temp = loadB(REGXSP); REGXSP += 1; return temp;}
__inline _u16 pop16(tw*rg) { _u16 temp = loadW(REGXSP); REGXSP += 2; return temp;}
__inline _u32 pop32(tw*rg) { _u32 temp = loadL(REGXSP); REGXSP += 4; return temp;}

//=============================================================================
/*
extern _u8*	gpcptr;	//Relative PC memory base adress
#define FETCH8()  (gpcptr[_pc++])
__inline FETCH16() { int v; _pc+=2; v=(gpcptr[0]<<8)|(gpcptr[1]);gpcptr+=2;return v; }
__inline FETCH24() { int v; _pc+=3; v=(gpcptr[0]<<16)|(gpcptr[1]<<8)|(gpcptr[2]);gpcptr+=3;return v; }
__inline FETCH32() { int v; _pc+=4; v=(gpcptr[0]<<24)|(gpcptr[1]<<16)|(gpcptr[2]<<8)|(gpcptr[0]);gpcptr+=4;return v; }
*/

//=============================================================================

_u8 statusIFF(tw*rg);
void setStatusIFF(tw*rg,_u8 iff);

void setStatusRFP(tw*rg,_u8 rfp);
void changedSP(tw*rg);

#define FLAG_S (((rg->status) & 0x0080) >> 7)
#define FLAG_Z (((rg->status) & 0x0040) >> 6)
#define FLAG_H (((rg->status) & 0x0010) >> 4)
#define FLAG_V (((rg->status) & 0x0004) >> 2)
#define FLAG_N (((rg->status) & 0x0002) >> 1)
#define FLAG_C ((rg->status) & 1)

#define TFLAG_S ((rg->status) & 0x0080)
#define TFLAG_Z ((rg->status) & 0x0040)
#define TFLAG_H ((rg->status) & 0x0010)
#define TFLAG_V ((rg->status) & 0x0004)
#define TFLAG_N ((rg->status) & 0x0002)
#define TFLAG_C ((rg->status) & 1)

#define DFLAG_S (rg->status>>7)
#define DFLAG_Z (rg->status>>6)
#define DFLAG_H (rg->status>>4)
#define DFLAG_V (rg->status>>2)
#define DFLAG_N (rg->status>>1)
#define DFLAG_C (rg->status)

#define CF_F	0
#define CF_LT	(1&((DFLAG_S^DFLAG_V)))
#define CF_LE	(1&((DFLAG_Z|(DFLAG_S^DFLAG_V))))
#define CF_ULE	(1&((DFLAG_C|DFLAG_Z)))
#define CF_OV	(1&((DFLAG_V)))
#define CF_MI	(1&((DFLAG_S)))
#define CF_Z	(1&((DFLAG_Z)))
#define CF_C	(1&((DFLAG_C)))
#define CF_T	1
#define CF_GE	(1&(~(DFLAG_S^DFLAG_V)))
#define CF_GT	(1&(~(DFLAG_Z|(DFLAG_S^DFLAG_V))))
#define CF_UGT	(1&(~(DFLAG_C|DFLAG_Z)))
#define CF_NOV	(1&(~(DFLAG_V)))
#define CF_PL	(1&(~(DFLAG_S)))
#define CF_NZ	(1&(~(DFLAG_Z)))
#define CF_NC	(1&(~(DFLAG_C)))


#define SETFLAG_S8(s) { (rg->status) =(((rg->status)^s)&(~0x80))^s; }
#define SETFLAG_S16(s) { (rg->status) =(((rg->status)^(s>>8))&(~0x80))^(s>>8); }
#define SETFLAG_S32(s) { (rg->status) =(((rg->status)^(s>>24))&(~0x80))^(s>>24); }

#define SETFLAG_Z(s) { if(s) (rg->status)|=0x40; else (rg->status)&=~0x40; }

#define SETFLAG_S(s) { _u16 sr1 = (rg->status) & 0xFF7F; if (s) sr1 |= 0x0080; (rg->status) = sr1; }
//#define SETFLAG_Z(z) { _u16 sr1 = (rg->status) & 0xFFBF; if (z) sr1 |= 0x0040; (rg->status) = sr1; }
#define SETFLAG_H(h) { _u16 sr1 = (rg->status) & 0xFFEF; if (h) sr1 |= 0x0010; (rg->status) = sr1; }
#define SETFLAG_V(v) { _u16 sr1 = (rg->status) & 0xFFFB; if (v) sr1 |= 0x0004; (rg->status) = sr1; }
#define SETFLAG_N(n) { _u16 sr1 = (rg->status) & 0xFFFD; if (n) sr1 |= 0x0002; (rg->status) = sr1; }
#define SETFLAG_C(c) { _u16 sr1 = (rg->status) & 0xFFFE; if (c) sr1 |= 0x0001; (rg->status) = sr1; }

#define SETFLAG_S0		{ (rg->status) &= 0xFF7F;	}
#define SETFLAG_Z0		{ (rg->status) &= 0xFFBF;	}
#define SETFLAG_H0		{ (rg->status) &= 0xFFEF;	}
#define SETFLAG_V0		{ (rg->status) &= 0xFFFB;	}
#define SETFLAG_N0		{ (rg->status) &= 0xFFFD;	}
#define SETFLAG_C0		{ (rg->status) &= 0xFFFE;	}

#define SETFLAG_S1		{ (rg->status) |= 0x0080; }
#define SETFLAG_Z1		{ (rg->status) |= 0x0040; }
#define SETFLAG_H1		{ (rg->status) |= 0x0010; }
#define SETFLAG_V1		{ (rg->status) |= 0x0004; }
#define SETFLAG_N1		{ (rg->status) |= 0x0002; }
#define SETFLAG_C1		{ (rg->status) |= 0x0001; }

//=============================================================================

//=============================================================================

//DIV ===============
_u16 generic_DIV_B(tw*rg,_u16 val, _u8 div);
_u32 generic_DIV_W(tw*rg,_u32 val, _u16 div);

//DIVS ===============
_u16 generic_DIVS_B(tw*rg,_s16 val, _s8 div);
_u32 generic_DIVS_W(tw*rg,_s32 val, _s16 div);

//ADD ===============
//_u8	generic_ADD_B(_u8 dst, _u8 src);
//_u16 generic_ADD_W(_u16 dst, _u16 src);
//_u32 generic_ADD_L(_u32 dst, _u32 src);

//ADC ===============
//_u8	generic_ADC_B(_u8 dst, _u8 src);
//_u16 generic_ADC_W(_u16 dst, _u16 src);
//_u32 generic_ADC_L(_u32 dst, _u32 src);

//SUB ===============
//_u8	generic_SUB_B(_u8 dst, _u8 src);
//_u16 generic_SUB_W(_u16 dst, _u16 src);
//_u32 generic_SUB_L(_u32 dst, _u32 src);

//SBC ===============
//_u8	generic_SBC_B(_u8 dst, _u8 src);
//_u16 generic_SBC_W(_u16 dst, _u16 src);
//_u32 generic_SBC_L(_u32 dst, _u32 src);

//=============================================================================

//Confirms a condition code check
//BOOL conditionCode(int cc);

//=============================================================================

//Translate an rr or RR value for MUL/MULS/DIV/DIVS
//_u8 get_rr_Target(tw*rg);
//_u8 get_RR_Target(tw*rg);

//=============================================================================

//=========================================================================

//===== LD (mem),#
void dstLDBi(tw*rg);

//===== LD (mem),#
void dstLDWi(tw*rg);

//===== POP (mem)
void dstPOPB(tw*rg);

//===== POP (mem)
void dstPOPW(tw*rg);

//===== LD (mem),(nn)
void dstLDBm16(tw*rg);

//===== LD (mem),(nn)
void dstLDWm16(tw*rg);

//===== LDA R,mem
void dstLDAW(tw*rg);

//===== LDA R,mem
void dstLDAL(tw*rg);

//===== ANDCF A,(mem)
void dstANDCFA(tw*rg);

//===== ORCF A,(mem)
void dstORCFA(tw*rg);

//===== XORCF A,(mem)
void dstXORCFA(tw*rg);

//===== LDCF A,(mem)
void dstLDCFA(tw*rg);

//===== STCF A,(mem)
void dstSTCFA(tw*rg);

//===== LD (mem),R
void dstLDBR(tw*rg);

//===== LD (mem),R
void dstLDWR(tw*rg);

//===== LD (mem),R
void dstLDLR(tw*rg);

//===== ANDCF #3,(mem)
void dstANDCF(tw*rg);

//===== ORCF #3,(mem)
void dstORCF(tw*rg);

//===== XORCF #3,(mem)
void dstXORCF(tw*rg);

//===== LDCF #3,(mem)
void dstLDCF(tw*rg);

//===== STCF #3,(mem)
void dstSTCF(tw*rg);

//===== TSET #3,(mem)
void dstTSET(tw*rg);

//===== RES #3,(mem)
void dstRES(tw*rg);

//===== SET #3,(mem)
void dstSET(tw*rg);

//===== CHG #3,(mem)
void dstCHG(tw*rg);

//===== BIT #3,(mem)
void dstBIT(tw*rg);

//===== JP cc,mem
void dstJP(tw*rg);

//===== CALL cc,mem
void dstCALL(tw*rg);

//===== RET cc
void dstRET(tw*rg);

//=========================================================================
//=========================================================================

//===== LD r,#
void regLDi(tw*rg);

//===== PUSH r
void regPUSH(tw*rg);

//===== POP r
void regPOP(tw*rg);

//===== CPL r
void regCPL(tw*rg);

//===== NEG r
void regNEG(tw*rg);

//===== MUL rr,#
void regMULi(tw*rg);

//===== MULS rr,#
void regMULSi(tw*rg);

//===== DIV rr,#
void regDIVi(tw*rg);

//===== DIVS rr,#
void regDIVSi(tw*rg);

//===== LINK r,dd
void regLINK(tw*rg);

//===== UNLK r
void regUNLK(tw*rg);

//===== BS1F A,r
void regBS1F(tw*rg);

//===== BS1B A,r
void regBS1B(tw*rg);

//===== DAA r
void regDAA(tw*rg);

//===== EXTZ r
void regEXTZ(tw*rg);

//===== EXTS r
void regEXTS(tw*rg);

//===== PAA r
void regPAA(tw*rg);

//===== MIRR r
void regMIRR(tw*rg);

//===== MULA r
void regMULA(tw*rg);

//===== DJNZ r,d
void regDJNZ(tw*rg);

//===== ANDCF #,r
void regANDCFi(tw*rg);

//===== ORCF #,r
void regORCFi(tw*rg);

//===== XORCF #,r
void regXORCFi(tw*rg);

//===== LDCF #,r
void regLDCFi(tw*rg);

//===== STCF #,r
void regSTCFi(tw*rg);

//===== ANDCF A,r
void regANDCFA(tw*rg);

//===== ORCF A,r
void regORCFA(tw*rg);

//===== XORCF A,r
void regXORCFA(tw*rg);

//===== LDCF A,r
void regLDCFA(tw*rg);

//===== STCF A,r
void regSTCFA(tw*rg);

//===== LDC cr,r
void regLDCcrr(tw*rg);

//===== LDC r,cr
void regLDCrcr(tw*rg);

//===== RES #,r
void regRES(tw*rg);

//===== SET #,r
void regSET(tw*rg);

//===== CHG #,r
void regCHG(tw*rg);

//===== BIT #,r
void regBIT(tw*rg);

//===== TSET #,r
void regTSET(tw*rg);

//===== MINC1 #,r
void regMINC1(tw*rg);

//===== MINC2 #,r
void regMINC2(tw*rg);

//===== MINC4 #,r
void regMINC4(tw*rg);

//===== MDEC1 #,r
void regMDEC1(tw*rg);

//===== MDEC2 #,r
void regMDEC2(tw*rg);

//===== MDEC4 #,r
void regMDEC4(tw*rg);

//===== MUL RR,r
void regMUL(tw*rg);

//===== MULS RR,r
void regMULS(tw*rg);

//===== DIV RR,r
void regDIV(tw*rg);

//===== DIVS RR,r
void regDIVS(tw*rg);

//===== INC #3,r
void regINC(tw*rg);

//===== DEC #3,r
void regDEC(tw*rg);

//===== SCC cc,r
void regSCC(tw*rg);

//===== LD R,r
void regLDRr(tw*rg);

//===== LD r,R
void regLDrR(tw*rg);

//===== ADD R,r
void regADD(tw*rg);

//===== ADC R,r
void regADC(tw*rg);

//===== SUB R,r
void regSUB(tw*rg);

//===== SBC R,r
void regSBC(tw*rg);

//===== LD r,#3
void regLDr3(tw*rg);

//===== EX R,r
void regEX(tw*rg);

//===== ADD r,#
void regADDi(tw*rg);

//===== ADC r,#
void regADCi(tw*rg);

//===== SUB r,#
void regSUBi(tw*rg);

//===== SBC r,#
void regSBCi(tw*rg);

//===== CP r,#
void regCPi(tw*rg);

//===== AND r,#
void regANDi(tw*rg);

//===== OR r,#
void regORi(tw*rg);

//===== XOR r,#
void regXORi(tw*rg);

//===== AND R,r
void regAND(tw*rg);

//===== OR R,r
void regOR(tw*rg);

//===== XOR R,r
void regXOR(tw*rg);

//===== CP r,#3
void regCPr3(tw*rg);

//===== CP R,r
void regCP(tw*rg);

//===== RLC #,r
void regRLCi(tw*rg);

//===== RRC #,r
void regRRCi(tw*rg);

//===== RL #,r
void regRLi(tw*rg);

//===== RR #,r
void regRRi(tw*rg);

//===== SLA #,r
void regSLAi(tw*rg);

//===== SRA #,r
void regSRAi(tw*rg);

//===== SLL #,r
void regSLLi(tw*rg);

//===== SRL #,r
void regSRLi(tw*rg);

//===== RLC A,r
void regRLCA(tw*rg);

//===== RRC A,r
void regRRCA(tw*rg);

//===== RL A,r
void regRLA(tw*rg);

//===== RR A,r
void regRRA(tw*rg);

//===== SLA A,r
void regSLAA(tw*rg);

//===== SRA A,r
void regSRAA(tw*rg);

//===== SLL A,r
void regSLLA(tw*rg);

//===== SRL A,r
void regSRLA(tw*rg);

//=========================================================================

//=========================================================================

//===== NOP
void sngNOP(tw*rg);

//===== NORMAL
void sngNORMAL(tw*rg);

//===== PUSH SR
void sngPUSHSR(tw*rg);

//===== POP SR
void sngPOPSR(tw*rg);

//===== MAX
void sngMAX(tw*rg);

//===== HALT
void sngHALT(tw*rg);

//===== EI #3
void sngEI(tw*rg);

//===== RETI
void sngRETI(tw*rg);

//===== LD (n), n
void sngLD8_8(tw*rg);

//===== PUSH n
void sngPUSH8(tw*rg);

//===== LD (n), nn
void sngLD8_16(tw*rg);

//===== PUSH nn
void sngPUSH16(tw*rg);

//===== INCF
void sngINCF(tw*rg);

//===== DECF
void sngDECF(tw*rg);

//===== RET condition
void sngRET(tw*rg);

//===== RETD dd
void sngRETD(tw*rg);

//===== RCF
void sngRCF(tw*rg);

//===== SCF
void sngSCF(tw*rg);

//===== CCF
void sngCCF(tw*rg);

//===== ZCF
void sngZCF(tw*rg);

//===== PUSH A
void sngPUSHA(tw*rg);

//===== POP A
void sngPOPA(tw*rg);

//===== EX F,F'
void sngEX(tw*rg);

//===== LDF #3
void sngLDF(tw*rg);

//===== PUSH F
void sngPUSHF(tw*rg);

//===== POP F
void sngPOPF(tw*rg);

//===== JP nn
void sngJP16(tw*rg);

//===== JP nnn
void sngJP24(tw*rg);

//===== CALL #16
void sngCALL16(tw*rg);

//===== CALL #24
void sngCALL24(tw*rg);

//===== CALR $+3+d16
void sngCALR(tw*rg);

//===== LD R, n
void sngLDB0(tw*rg);
void sngLDB1(tw*rg);
void sngLDB2(tw*rg);
void sngLDB3(tw*rg);
void sngLDB4(tw*rg);
void sngLDB5(tw*rg);
void sngLDB6(tw*rg);
void sngLDB7(tw*rg);

//===== PUSH RR
void sngPUSHW0(tw*rg);
void sngPUSHW1(tw*rg);
void sngPUSHW2(tw*rg);
void sngPUSHW3(tw*rg);
void sngPUSHW4(tw*rg);
void sngPUSHW5(tw*rg);
void sngPUSHW6(tw*rg);
void sngPUSHW7(tw*rg);

//===== LD RR, nn
void sngLDW0(tw*rg);
void sngLDW1(tw*rg);
void sngLDW2(tw*rg);
void sngLDW3(tw*rg);
void sngLDW4(tw*rg);
void sngLDW5(tw*rg);
void sngLDW6(tw*rg);
void sngLDW7(tw*rg);

//===== PUSH XRR
void sngPUSHL0(tw*rg);
void sngPUSHL1(tw*rg);
void sngPUSHL2(tw*rg);
void sngPUSHL3(tw*rg);
void sngPUSHL4(tw*rg);
void sngPUSHL5(tw*rg);
void sngPUSHL6(tw*rg);
void sngPUSHL7(tw*rg);

//===== LD XRR, nnnn
void sngLDL0(tw*rg);
void sngLDL1(tw*rg);
void sngLDL2(tw*rg);
void sngLDL3(tw*rg);
void sngLDL4(tw*rg);
void sngLDL5(tw*rg);
void sngLDL6(tw*rg);
void sngLDL7(tw*rg);

//===== POP RR
void sngPOPW0(tw*rg);
void sngPOPW1(tw*rg);
void sngPOPW2(tw*rg);
void sngPOPW3(tw*rg);
void sngPOPW4(tw*rg);
void sngPOPW5(tw*rg);
void sngPOPW6(tw*rg);
void sngPOPW7(tw*rg);

//===== POP XRR
void sngPOPL0(tw*rg);
void sngPOPL1(tw*rg);
void sngPOPL2(tw*rg);
void sngPOPL3(tw*rg);
void sngPOPL4(tw*rg);
void sngPOPL5(tw*rg);
void sngPOPL6(tw*rg);
void sngPOPL7(tw*rg);

//===== JR cc,_pc + d
//POKE
void sngJR_F	(tw*rg)	;
void sngJR_LT	(tw*rg)	;
void sngJR_LE	(tw*rg)	;
void sngJR_ULE	(tw*rg)	;
void sngJR_OV	(tw*rg)	;
void sngJR_MI	(tw*rg)	;
void sngJR_Z	(tw*rg)	;
void sngJR_C	(tw*rg)	;
void sngJR_T	(tw*rg)	;
void sngJR_GE	(tw*rg)	;
void sngJR_GT	(tw*rg)	;
void sngJR_UGT	(tw*rg)	;
void sngJR_NOV	(tw*rg)	;
void sngJR_PL	(tw*rg)	;
void sngJR_NZ	(tw*rg)	;
void sngJR_NC	(tw*rg)	;

//===== JRL cc,_pc + d
//POKE
void sngJRL_F	(tw*rg)	;
void sngJRL_LT	(tw*rg)	;
void sngJRL_LE	(tw*rg)	;
void sngJRL_ULE	(tw*rg)	;
void sngJRL_OV	(tw*rg)	;
void sngJRL_MI	(tw*rg)	;
void sngJRL_Z	(tw*rg)	;
void sngJRL_C	(tw*rg)	;
void sngJRL_T	(tw*rg)	;
void sngJRL_GE	(tw*rg)	;
void sngJRL_GT	(tw*rg)	;
void sngJRL_UGT	(tw*rg)	;
void sngJRL_NOV	(tw*rg)	;
void sngJRL_PL	(tw*rg)	;
void sngJRL_NZ	(tw*rg)	;
void sngJRL_NC	(tw*rg)	;


//===== LDX dst,src
void sngLDX(tw*rg);

//===== SWI num
void sngSWI(tw*rg);

//=============================================================================
//=========================================================================

//===== PUSH (mem)
void srcPUSH(tw*rg);

//===== RLD A,(mem)
void srcRLD(tw*rg);

//===== RRD A,(mem)
void srcRRD(tw*rg);

//===== LDI
void srcLDI(tw*rg);

//===== LDIR
void srcLDIR(tw*rg);

//===== LDD
void srcLDD(tw*rg);

//===== LDDR
void srcLDDR(tw*rg);

//===== CPI
void srcCPI(tw*rg);

//===== CPIR
void srcCPIR(tw*rg);

//===== CPD
void srcCPD(tw*rg);

//===== CPDR
void srcCPDR(tw*rg);

//===== LD (nn),(mem)
void srcLD16m(tw*rg);

//===== LD R,(mem)
void srcLD(tw*rg);

//===== EX (mem),R
void srcEX(tw*rg);

//===== ADD (mem),#
void srcADDi(tw*rg);

//===== ADC (mem),#
void srcADCi(tw*rg);

//===== SUB (mem),#
void srcSUBi(tw*rg);

//===== SBC (mem),#
void srcSBCi(tw*rg);

//===== AND (mem),#
void srcANDi(tw*rg);

//===== OR (mem),#
void srcORi(tw*rg);

//===== XOR (mem),#
void srcXORi(tw*rg);

//===== CP (mem),#
void srcCPi(tw*rg);

//===== MUL RR,(mem)
void srcMUL(tw*rg);

//===== MULS RR,(mem)
void srcMULS(tw*rg);

//===== DIV RR,(mem)
void srcDIV(tw*rg);

//===== DIVS RR,(mem)
void srcDIVS(tw*rg);

//===== INC #3,(mem)
void srcINC(tw*rg);

//===== DEC #3,(mem)
void srcDEC(tw*rg);

//===== RLC (mem)
void srcRLC(tw*rg);

//===== RRC (mem)
void srcRRC(tw*rg);

//===== RL (mem)
void srcRL(tw*rg);

//===== RR (mem)
void srcRR(tw*rg);

//===== SLA (mem)
void srcSLA(tw*rg);

//===== SRA (mem)
void srcSRA(tw*rg);

//===== SLL (mem)
void srcSLL(tw*rg);

//===== SRL (mem)
void srcSRL(tw*rg);

//===== ADD R,(mem)
void srcADDRm(tw*rg);

//===== ADD (mem),R
void srcADDmR(tw*rg);

//===== ADC R,(mem)
void srcADCRm(tw*rg);

//===== ADC (mem),R
void srcADCmR(tw*rg);

//===== SUB R,(mem)
void srcSUBRm(tw*rg);

//===== SUB (mem),R
void srcSUBmR(tw*rg);

//===== SBC R,(mem)
void srcSBCRm(tw*rg);

//===== SBC (mem),R
void srcSBCmR(tw*rg);

//===== AND R,(mem)
void srcANDRm(tw*rg);

//===== AND (mem),R
void srcANDmR(tw*rg);

//===== XOR R,(mem)
void srcXORRm(tw*rg);

//===== XOR (mem),R
void srcXORmR(tw*rg);

//===== OR R,(mem)
void srcORRm(tw*rg);

//===== OR (mem),R
void srcORmR(tw*rg);

//===== CP R,(mem)
void srcCPRm(tw*rg);

//===== CP (mem),R
void srcCPmR(tw*rg);

//=============================================================================

extern void (*decode[256])(tw*);

extern _u8 doTLCS900H_Fast();
extern _u8 doTLCS900H_Med();
extern _u8 doTLCS900H_Comp();
extern _u8 doTLCS900H_Z80_Fast();
extern _u8 doTLCS900H_Z80_Med();



#endif

