
#ifndef __SOUND__
#define __SOUND__
//=============================================================================

typedef struct
{
	int LastRegister;	/* last register written */
	int Register[8];	/* registers */
	int Volume[4];		
	int Period[4];		
	int Count[4];		
	int Output[4];		

	unsigned int RNG;	/* noise generator      */
	int NoiseFB;		/* noise feedback mask */

} SoundChip; 


typedef struct
{
    int sample_rate;    /* Sample rate (8000-44100) */
    int enabled;        /* 1= sound emulation is enabled */
    int bufsize;        /* Size of sound buffer (in bytes) */
    _u16 *buffer[2];   /* Signed 16-bit stereo sound data */
}t_snd;

extern t_snd snd; // definie dans gpmain

//=============================================================================

extern SoundChip toneChip;
extern SoundChip noiseChip;

void WriteSoundChip(SoundChip* chip, _u8 data);

#define Write_SoundChipTone(VALUE)		(WriteSoundChip(&toneChip, VALUE))
#define Write_SoundChipNoise(VALUE)		(WriteSoundChip(&noiseChip, VALUE))

//=============================================================================

void dac_write(void);

//=============================================================================
#endif
