
#ifndef __INTERRUPT__
#define __INTERRUPT__
//=============================================================================

#define CPU_FREQ__1_1
//#define CPU_FREQ__1_2
//#define CPU_FREQ__1_4
//#define CPU_FREQ__1_6
//#define CPU_FREQ__1_8

#ifdef CPU_FREQ__1_1
 #define TIMER_HINT_RATE		515		//CPU Ticks between horizontal interrupts
 #define TIMER_BASE_RATE		240		//ticks
#endif

#ifdef CPU_FREQ__1_2
 #define TIMER_HINT_RATE		257		//CPU Ticks between horizontal interrupts
 #define TIMER_BASE_RATE		120		//ticks
#endif

#ifdef CPU_FREQ__1_4
 #define TIMER_HINT_RATE		129		//CPU Ticks between horizontal interrupts
 #define TIMER_BASE_RATE		 60		//ticks
#endif

#ifdef CPU_FREQ__1_6
 #define TIMER_HINT_RATE		 86		//CPU Ticks between horizontal interrupts
 #define TIMER_BASE_RATE		 40		//ticks
#endif

#ifdef CPU_FREQ__1_8
 #define TIMER_HINT_RATE		 64		//CPU Ticks between horizontal interrupts
 #define TIMER_BASE_RATE		 30		//ticks
#endif

#define TIMER_T1_RATE		(1 * TIMER_BASE_RATE)
#define TIMER_T4_RATE		(4 * TIMER_BASE_RATE)
#define TIMER_T16_RATE		(16 * TIMER_BASE_RATE)
#define TIMER_T256_RATE		(256 * TIMER_BASE_RATE)

void interrupt(_u8 index);
void reset_timers(void);

//Call this after each instruction
void updateTimers(_u8 cputicks);

//H-INT Timer
extern _u32 timer_hint;
extern _u8 timer[4];	//Up-counters
extern _u32 timer_clock0, timer_clock1, timer_clock2, timer_clock3;

// Set this value to fix problems with glitching extra lines.
extern BOOL gfx_hack;

//=============================================================================
#endif




