#include "snes9x.h"

#include "os9xZ_openspc.h"
#include "openspc.h"


openspc *ospc;
char *spc_data;

#include "TapWave.h"
#include "SoundMgr.h"
static SndStreamRef snd_stream;
typedef struct {uint32 __r9;uint32 __r10;} reg_sys_t;
static reg_sys_t reg_sys;

int spc_sndFrequency=44100;
int spc_sndBuffsize=1024*16;
int16 *real_buffer;
volatile int spc_callbackin=0;

int playing_time,start_time;

static Err spc_sndCallBack (void *userData,SndStreamRef stream, void *bufferZ,UInt32 frameCountZ)
{
/*	long long j;
	int i,k,l,m;
	int16 *src,*dst,valL,valR,valLa,valRa;
*/
	__asm 
	{
		stmfd  r13!,{r9,r10}
		ldr	   r9,[r0]
		ldr	   r10,[r0,#4]
	}	
	if (!spc_callbackin)
	{
		spc_callbackin=1;
		ospc->run(-1,(int16*)bufferZ,(int)(frameCountZ*4));
		spc_callbackin=0;
	}
		
	__asm 
	{
		ldmfd  r13!,{r9,r10}
	}
	return errNone;
}


int OSPC_Init()
{
    int i;    
    __asm 
  	{
  		ldr  r0, = reg_sys
	  	add	 r0,r0,r10
  		str	 r9,[r0]
	  	str	 r10,[r0,#4]
  	} 
  	SndStreamCreate(&snd_stream,sndOutput,spc_sndFrequency,sndInt16Little,sndStereo,spc_sndCallBack,&reg_sys,spc_sndBuffsize);
  	real_buffer=(int16*)MemPtrNew(spc_sndBuffsize*4*4);
	ospc=new openspc();
	return 0;
}

void OSPC_Close(void)
{
	
	delete ospc;
	ljz_free(spc_data);	
}

SPC_ID666 *OSPC_GetID666(char *buf)
{
  SPC_ID666 *id;
  char tmps[16];
  int i;

  id = (SPC_ID666 *)ljz_malloc(sizeof(*id));
  if (id == NULL)
    return NULL;

  
  if (buf[0x23] == 27) {  
      ljz_free(id);
      return NULL;
  }

  memcpy(id->songname,buf+0x2E,32);  
  id->songname[32] = '\0';

  memcpy(id->gametitle,buf+32+0x2E,32); 
  id->gametitle[32] = '\0';

  memcpy(id->dumper,buf+32*2+0x2E,16);
  id->dumper[16] = '\0';

  memcpy(id->dumper,buf+32*2+17+0x2E,32);  
  id->comments[32] = '\0';

  switch (buf[0xD1]) {
  case 1:
      id->emulator = SPC_EMULATOR_ZSNES;
      break;
  case 2:
      id->emulator = SPC_EMULATOR_SNES9X;
      break;
  case 0:
  default:
      id->emulator = SPC_EMULATOR_UNKNOWN;
      break;
  }

  memcpy(id->author,buf+0xB0,32);  
  id->author[32] = '\0';
  
  tmps[0]=buf[0xA9];
  tmps[1]=buf[0xAA];
  tmps[2]=buf[0xAB];
  tmps[3]=0;
  id->playtime=0;
  i=0;
  while (tmps[i])
  {
	id->playtime*=10;
  	id->playtime+=tmps[i]-'0';
  	i++;
  }
  tmps[0]=buf[0xAC];
  tmps[1]=buf[0xAD];
  tmps[2]=buf[0xAE];
  tmps[3]=buf[0xAF];
  tmps[4]=0;
  id->fadetime=0;
  while (tmps[i])
  {
	id->fadetime*=10;
  	id->fadetime+=tmps[i]-'0';
  	i++;
  }
  

  return id;
  
}

int OSPC_Load(char *fname)
{
  int err_code;
  FILE  *f;  
  unsigned long filesize;

  f=fopen(fname,"rb");
  if (f)
  { 
  	fseek(f,-1,SEEK_END); //bug in palmos until now...
  	filesize=ftell(f)+1;
  	fseek(f,0,SEEK_SET); 	
  	spc_data=(char*)ljz_malloc(filesize);
	fread(spc_data,filesize,1,f);
	fclose(f);
	return ospc->init(spc_data,filesize);
  }
  else 
  {
  	spc_data=NULL;
  	return -1;
  }    
}

void OSPC_Stop(void)
{
	SndStreamDelete(snd_stream);
}

int os9x_spc_time(void)
{
	int64 l;
	l=TimGetTicks();		
	return l*1000/SysTicksPerSecond();
}
void OSPC_Play(char *fname)
{
    int i,j;
    char str[256];
    SPC_ID666 *id;
    char *emulator[3]={"Unknown","Zsnes","Snes9x"};
    uint8 *scr;
    
    OSPC_Init();
    if (i=OSPC_Load(fname))
    {
    	sprintf(str,"Error at SPC loading, code : %d",i);
    	menu_message(str);
    	//gp32_pause();
    	//GpAppExit();
    	return;
    }
     
	
	id=OSPC_GetID666(spc_data);
	if (id)
	{
//		DrawWindow2((char*)(vrambuffer), 15, 50, 300-15*2, 100 , COLOR_YELLOW,COLOR_ORANGE);	
  		sprintf(str,"Song : %s",id->songname);
  		//menu_message(str);
		menu_messageRaw(20,50,str);
//		gp32_GpTextOut(vrambuffer,20,58,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Game : %s",id->gametitle);
		menu_messageRaw(20,80,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*1,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Dumper : %s",id->dumper);
		menu_messageRaw(20,110,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*2,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Comments : %s",id->comments);
		menu_messageRaw(20,140,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*3,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Author : %s",id->author);
		menu_messageRaw(20,170,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*4,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Emulator used : %s",emulator[id->emulator]);
		menu_messageRaw(20,200,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*5,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		sprintf(str,"Playtime : %02d:%02d / Fade : %dms",id->playtime/60,id->playtime%60,id->fadetime);
		menu_messageRaw(20,230,str);
//		gp32_GpTextOut(vrambuffer,20,58+12*6,str,(31<<11)|(24<<6)|(16<<1)|1,1);	
		
		ljz_free(id);
	}
	
	
  	RectangleType *item_rect;
    item_rect=(RectangleType*)ljz_malloc(21*sizeof(RectangleType));
    char tmp[16];
    int x,y;
  	menu_button(310,20,(char*)"LAUNCHER",4,&item_rect[0],2);
  	
  	
  	start_time=os9x_spc_time();
  	
  	SndStreamStart(snd_stream);
    for (;;) 
    {			   	
    	menu_waitPen(&x,&y,3);
		//BACK	  
	    if (TEST_PEN_MENU(x,y,item_rect[0])) {break;}

		playing_time=(os9x_spc_time()-start_time)/1000;		
		if (playing_time<0)
		{
			start_time=os9x_spc_time();
			playing_time=(os9x_spc_time()-start_time)/1000;		
		}
		
		
		
		scr=WinScreenLock(winLockCopy);  		
		sprintf(str,"%02d:%02d",playing_time/60,playing_time%60);
		menu_button(20,260,str,6,NULL,2);				
		if (scr) WinScreenUnlock();
    }
    menu_waitPen(NULL,NULL,2); //to flush
    
    ljz_free(item_rect);
    
    OSPC_Stop();            
    OSPC_Close();    
}
