#if 1

/*
 * Snes9x - Portable Super Nintendo Entertainment System (TM) emulator.
 *
 * (c) Copyright 1996 - 2001 Gary Henderson (gary.henderson@ntlworld.com) and
 *                           Jerremy Koot (jkoot@snes9x.com)
 *
 * Super FX C emulator code 
 * (c) Copyright 1997 - 1999 Ivar (ivar@snes9x.com) and
 *                           Gary Henderson.
 * Super FX assembler emulator code (c) Copyright 1998 zsKnight and _Demo_.
 *
 * DSP1 emulator code (c) Copyright 1998 Ivar, _Demo_ and Gary Henderson.
 * C4 asm and some C emulation code (c) Copyright 2000 zsKnight and _Demo_.
 * C4 C code (c) Copyright 2001 Gary Henderson (gary.henderson@ntlworld.com).
 *
 * DOS port code contains the works of other authors. See headers in
 * individual files.
 *
 * Snes9x homepage: http://www.snes9x.com
 *
 * Permission to use, copy, modify and distribute Snes9x in both binary and
 * source form, for non-commercial purposes, is hereby granted without fee,
 * providing that this license information and copyright notice appear with
 * all copies and any derived work.
 *
 * This software is provided 'as-is', without any express or implied
 * warranty. In no event shall the authors be held liable for any damages
 * arising from the use of this software.
 *
 * Snes9x is freeware for PERSONAL USE only. Commercial users should
 * seek permission of the copyright holders first. Commercial use includes
 * charging money for Snes9x or software derived from Snes9x.
 *
 * The copyright holders request that bug fixes and improvements to the code
 * should be forwarded to them so everyone can benefit from the modifications
 * in future versions.
 *
 * Super NES and Super Nintendo Entertainment System are trademarks of
 * Nintendo Co., Limited and its subsidiary companies.
 */
 
//#ifndef asmPPU
#include "snes9x.h"

#include "memmap.h"
#include "ppu.h"
#include "cpuexec.h"
#include "display.h"
#include "gfx.h"
#include "apu.h"

#include <tapwave.h>

typedef union
{
    struct { uint8 b0,b1,b2,b3; } B;
    uint32 W;
} yo_uint32;

extern TwGfxSurfaceType* os9x_curRenderingScreen,*os9x_curTileCache,*os9x_tmpRenderingScreen;
extern TwGfxBitmapType tmp_sprBitmap;


/******************************/
#define TILE_HEADER \
    uint8 *pCache,*pCacheRam; \
    uint32 Col; \
    uint32 TileAddr = BG.TileAddress + ((Tile & 0x3ff) << BG.TileShift); \
    if ((Tile & 0x1ff) >= 256) TileAddr += BG.NameSelect; \
    TileAddr &= 0xffff; \
    if (BG.DirectColourMode) \
    { \
        /*Did the palette changed ?*/ \
	if (IPPU.DirectColourMapsNeedRebuild) S9xBuildDirectColourMaps (); \
        GFX.ScreenColors = DirectColourMaps [(Tile >> 10) & BG.PaletteMask]; \
        Col = 0; \
    } \
    else  \
    { \
    	GFX.ScreenColors = &IPPU.ScreenColors [(((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette]; \
    	Col = (((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette; \
    } \
    uint32 TileNumber=(TileAddr >> BG.TileShift); \
    /* 64 Tile / line & 128bytes / tile => 64*128bytes/line 64*128=1<<13*/ \
    pCache = &BG.Buffer[((TileNumber>>6)<<13 )|((TileNumber&63)<<4)]; \
	pCacheRam = &BG.BufferRam[TileNumber<<6];     \
    if (!BG.Buffered [TileNumber<<1])  \
    { \
   		BG.Buffered[TileNumber<<1] = ConvertTile16New (pCacheRam, TileAddr,GFX.ScreenColors); \
    	uint16 *r = (uint16*)(pCache); \
		uint8 *s=pCacheRam; \
		uint16 saveCol0=GFX.ScreenColors[0]; \
		GFX.ScreenColors[0]=(1<<5); \
		for (int line = 8;line;line--,r+=64*8-8) \
		{ \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
		} \
		GFX.ScreenColors[0]=saveCol0; \
		BG.Buffered[(TileNumber<<1)|1] = Col; \
    } \
    else \
    if (BG.Buffered [(TileNumber<<1)|1]!=Col) \
    { \
	    uint16 *r = (uint16*)(pCache); \
		uint8 *s=pCacheRam; \
		uint16 saveCol0=GFX.ScreenColors[0]; \
		GFX.ScreenColors[0]=(1<<5); \
		for (int line = 8;line;line--,r+=64*8-8) \
		{ \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
			*r++=GFX.ScreenColors[*s++];*r++=GFX.ScreenColors[*s++]; \
		} \
		GFX.ScreenColors[0]=saveCol0; \
		BG.Buffered[(TileNumber<<1)|1] = Col; \
    } \
    if (BG.Buffered [TileNumber<<1] == 1) /*BLANK_TILE*/ \
		return; \
    /*Tile is not blank, 'have to draw it*/

/******************************/


inline uint8 ConvertTile16New (uint8 *pCacheRam,uint32 TileAddr,uint16 *ScreenColors)
{
    register uint8 *tp = &Memory.VRAM[TileAddr];
    uint8 *p = pCacheRam;//tmpCache;
    uint32 non_zero,tile_opaque;
    uint8 line;
    yo_uint32 p1;
    yo_uint32 p2;
    register uint8 pix;
	    
    non_zero=0;	
    switch (BG.BitShift)
    {
    case 8:
	for (line = 8; line != 0; line--, tp += 2)
	{
	    p1.W = 0;
	    p2.W = 0;	    	    
	    if ((pix = *(tp + 0)))
	    {
		p1.W |= odd_high[0][pix >> 4];
		p2.W |= odd_low[0][pix & 0xf];
	    }
	    if ((pix = *(tp + 1)))
	    {
		p1.W |= even_high[0][pix >> 4];
		p2.W |= even_low[0][pix & 0xf];
	    }
	    if ((pix = *(tp + 16)))
	    {
		p1.W |= odd_high[1][pix >> 4];
		p2.W |= odd_low[1][pix & 0xf];
	    }
	    if ((pix = *(tp + 17)))
	    {
		p1.W |= even_high[1][pix >> 4];
		p2.W |= even_low[1][pix & 0xf];
	    }
	    if ((pix = *(tp + 32)))
	    {
		p1.W |= odd_high[2][pix >> 4];
		p2.W |= odd_low[2][pix & 0xf];
	    }
	    if ((pix = *(tp + 33)))
	    {
		p1.W |= even_high[2][pix >> 4];
		p2.W |= even_low[2][pix & 0xf];
	    }
	    if ((pix = *(tp + 48)))
	    {
		p1.W |= odd_high[3][pix >> 4];
		p2.W |= odd_low[3][pix & 0xf];
	    }
	    if ((pix = *(tp + 49)))
	    {
		p1.W |= even_high[3][pix >> 4];
		p2.W |= even_low[3][pix & 0xf];
	    }	    	    
	    
	    
	    p[0]  = p1.B.b0;
	    p[1]  = p1.B.b1;
	    p[2] = p1.B.b2;
	    p[3] = p1.B.b3;
	    p[4] = p2.B.b0;
	    p[5] = p2.B.b1;
	    p[6] = p2.B.b2;
	    p[7] = p2.B.b3;
	    
	    p+=8;
	    non_zero |= p1.W | p2.W;	    	    
	}
	break;

    case 4:
	for (line = 8; line != 0; line--, tp += 2)
	{
	    p1.W = 0;
	    p2.W = 0;	    
	    if ((pix = *(tp + 0)))
	    {
		p1.W |= odd_high[0][pix >> 4];
		p2.W |= odd_low[0][pix & 0xf];
	    }
	    if ((pix = *(tp + 1)))
	    {
		p1.W |= even_high[0][pix >> 4];
		p2.W |= even_low[0][pix & 0xf];
	    }
	    if ((pix = *(tp + 16)))
	    {
		p1.W |= odd_high[1][pix >> 4];
		p2.W |= odd_low[1][pix & 0xf];
	    }
	    if ((pix = *(tp + 17)))
	    {
		p1.W |= even_high[1][pix >> 4];
		p2.W |= even_low[1][pix & 0xf];
	    }	    
	    p[0]  = p1.B.b0;
	    p[1]  = p1.B.b1;
	    p[2] = p1.B.b2;
	    p[3] = p1.B.b3;
	    p[4] = p2.B.b0;
	    p[5] = p2.B.b1;
	    p[6] = p2.B.b2;
	    p[7] = p2.B.b3;
	    
	    p+=8;
	    non_zero |= p1.W | p2.W;	    	    
	}
	break;

    case 2:    	
	for (line = 8; line != 0; line--, tp += 2)
	{
	    p1.W = 0;
	    p2.W = 0; 	    
	    if ((pix = *(tp + 0)))
	    {
		p1.W |= odd_high[0][pix >> 4];
		p2.W |= odd_low[0][pix & 0xf];
	    }
	    if ((pix = *(tp + 1)))
	    {
		p1.W |= even_high[0][pix >> 4];
		p2.W |= even_low[0][pix & 0xf];
	    }	    	   
	    
	    p[0]  = p1.B.b0;
	    p[1]  = p1.B.b1;
	    p[2] = p1.B.b2;
	    p[3] = p1.B.b3;
	    p[4] = p2.B.b0;
	    p[5] = p2.B.b1;
	    p[6] = p2.B.b2;
	    p[7] = p2.B.b3;
	    
	    p+=8;
	    non_zero |= p1.W | p2.W;	    	    	}
	break;
	}		
	if (non_zero) 
	{	
		tile_opaque=1;
		p=pCacheRam;//tmpCache;	    
		for (line = 8;line; line--,p+=8)
		{
			if ((!p[0])|(!p[1])|(!p[2])|(!p[3])|(!p[4])|(!p[5])|(!p[6])|(!p[7])) 
			{
				tile_opaque=0;
				break;
			}
		}	    
		if (tile_opaque) return 2; //Tile is cached and opaque
		return 3; //Tile is cached and transp
	}		
	else return 1; //Tile is totally transparent		
}



void DrawTile16New (uint32 Tile, uint32 Offset, uint32 StartLine, uint32 LineCount)
{
	TILE_HEADER

    TwGfxRectType mSourceRect;
    TwGfxPointType mDestPos;
    mSourceRect.x=(TileNumber&63)<<3;    
    mSourceRect.w=8;	
    mDestPos.x=(Offset)&255;
    mDestPos.y=(Offset>>8);
    
    if (BG.Buffered [TileNumber<<1]==2) //opaque tile
    {		
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{	
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
			TwGfxBitBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect);	    
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
		}
    	else		
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
		}
		else //VFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
		}
    }
    else //transparent (partially) tile
    {			
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
			TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,TwGfxDisplayRGBToPackedRGB(1<<5));
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
    	{
    		TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
    	else
    	if (Tile & H_FLIP) //VFLIP & HFLIP
    	{
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
	else //VFLIP
	{
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
    }
		    
}

void DrawClippedTile16New (uint32 Tile, uint32 Offset,
			uint32 StartPixel, uint32 Width,
			uint32 StartLine, uint32 LineCount)
{		
	TILE_HEADER

    TwGfxRectType mSourceRect;
    TwGfxPointType mDestPos;    
    mDestPos.x=((Offset+StartPixel)&255);
    mDestPos.y=((Offset+StartPixel)>>8);
    
    if (BG.Buffered [TileNumber<<1]==2) //opaque tile
    {
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;	
			mSourceRect.x=((TileNumber&63)<<3)+StartPixel;    
			mSourceRect.w=Width;    
			TwGfxBitBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect);	    
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+8-(Width+StartPixel);
			mSourceRect.w=Width;    
    		TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
		}
    	else
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+8-(Width+StartPixel);
			mSourceRect.w=Width;    
			TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
		}
		else //VFLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+StartPixel;    
			mSourceRect.w=Width;    
			TwGfxTransformBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
		}
    }
    else //transparent (partially) tile
    {
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+StartPixel;    
			mSourceRect.w=Width;    
			TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,TwGfxDisplayRGBToPackedRGB(1<<5));
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
    	{
    		TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=Width;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+8-(Width+StartPixel);
			mSourceRect.w=Width;    
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
    	else
    	if (Tile & H_FLIP) //VFLIP & HFLIP
    	{
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=Width;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+8-(Width+StartPixel);
			mSourceRect.w=Width;    
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
		else //VFLIP
		{
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=Width;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
			mSourceRect.x=((TileNumber&63)<<3)+StartPixel;    
			mSourceRect.w=Width;    
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
    		TwGfxTransparentBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,TwGfxDisplayRGBToPackedRGB(1<<5));
    	}
    }
}

/******************************************************************/
/******************************************************************/
/*               */
/*       Sprites */
/*               */
/******************************************************************/
/******************************************************************/



void DrawTile16NewFastSprite (uint32 Tile, uint32 Offset, uint32 StartLine, uint32 LineCount, uint32 index_spr)
{
	DrawTile16New(Tile,Offset,StartLine,LineCount);
}



void DrawTile16NewSprite (uint32 Tile, uint32 Offset, uint32 StartLine, uint32 LineCount, uint32 index_spr)
{
	TILE_HEADER
    
   TwGfxRectType mSourceRect;
   TwGfxPointType mDestPos;
   mSourceRect.x=(TileNumber&63)<<3;    
   mSourceRect.w=8;	
   mDestPos.x=(Offset)&255;
   mDestPos.y=(Offset>>8);

    if (BG.Buffered [TileNumber<<1]==2) //opaque tile
    {	    		    
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{					
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4)
			{				
				tmp_mask=0;
				#define fn(N) \
				if (zb[N]>index_spr){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}	
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;							
			TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,&tmp_sprBitmap);
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4)
			{
				tmp_mask=0;
				#define fn(N) \
				if (zb[N]>index_spr){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
										
		}
    	else		
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{		
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4)
			{
				tmp_mask=0;
				#define fn(N) \
				if (zb[N]>index_spr){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
				
		}
		else //VFLIP
		{
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4)
			{
				tmp_mask=0;
				#define fn(N) \
				if (zb[N]>index_spr){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
			
		}
    }
    else //transparent (partially) tile
    {	    	
    if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{					
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			uint8 *pix=pCacheRam+(StartLine<<3);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4,pix+=8)
			{				
				tmp_mask=0;
				#define fn(N) \
				if ((zb[N]>index_spr)&&pix[N]){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}	
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;							
			TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_curTileCache,&mSourceRect,&tmp_sprBitmap);
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			uint8 *pix=pCacheRam+(StartLine<<3);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4,pix+=8)
			{
				tmp_mask=0;
				#define fn(N) \
				if ((zb[N]>index_spr)&&pix[7-N]) {tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+StartLine;
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorHorizontal);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
										
		}
    	else		
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{		
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			uint8 *pix=pCacheRam+((LineCount+StartLine-1)<<3);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4,pix-=8)
			{
				tmp_mask=0;
				#define fn(N) \
				if ((zb[N]>index_spr)&&pix[7-N]){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorBoth);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
				
		}
		else //VFLIP
		{
			uint8  *zb=GFX.ZBuffer+Offset;
			uint8 *mask=((uint8*)tmp_sprBitmap.data);
			uint8 *pix=pCacheRam+((LineCount+StartLine-1)<<3);
			register uint32 tmp_mask;
			for (int line=LineCount;line;line--,zb+=256,mask+=4,pix-=8)
			{
				tmp_mask=0;
				#define fn(N) \
				if ((zb[N]>index_spr)&&pix[N]){tmp_mask|=(1<<(7-N));zb[N]=index_spr;}
				fn(0)
				fn(1)
				fn(2)
				fn(3)
				fn(4)
				fn(5)
				fn(6)
				fn(7)
				#undef fn
				*mask=tmp_mask;
			}
			
			TwGfxPointType mDestPosTmp={0,0};
    		TwGfxRectType mSourceRectTmp;
    		mSourceRectTmp.x=0;
    		mSourceRectTmp.y=0;
    		mSourceRectTmp.w=8;
    		mSourceRectTmp.h=LineCount;
			mSourceRect.y=((TileNumber>>6)<<3)+8-(StartLine+LineCount);
			mSourceRect.h=LineCount;
    		TwGfxTransformBlt(os9x_tmpRenderingScreen,&mDestPosTmp,os9x_curTileCache,&mSourceRect,0,twGfxMirrorVertical);
    		TwGfxMaskBlt(os9x_curRenderingScreen,&mDestPos,os9x_tmpRenderingScreen,&mSourceRectTmp,&tmp_sprBitmap);
			
		}		   
    }

}


void DrawClippedTile16NewFastSprite (uint32 Tile, uint32 Offset,
			uint32 StartPixel, uint32 Width,
			uint32 StartLine, uint32 LineCount, uint32 index_spr)
{
	DrawClippedTile16New (Tile,Offset,StartPixel,Width,StartLine,LineCount);
}

void DrawClippedTile16NewSprite (uint32 Tile, uint32 Offset,
			uint32 StartPixel, uint32 Width,
			uint32 StartLine, uint32 LineCount, uint32 index_spr)
{
DrawClippedTile16New (Tile,Offset,StartPixel,Width,StartLine,LineCount);
return;
	TILE_HEADER

    
    if (BG.Buffered [TileNumber<<1]==2) //opaque tile
    {		
    	if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{	
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+(StartLine<<9)+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix+=8*64-Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{				
				if ((*zb)>index_spr) {*screen=*pix;*zb=index_spr;}
				zb++;pix++;screen++;
			}
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+(StartLine<<9)+Width+StartPixel-1;
			for (int line=LineCount;line;line--,screen+=256-Width,pix+=8*64+Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ((*zb)>index_spr) {*screen=*pix;*zb=index_spr;}
				zb++;pix--;screen++;
			}
		}
    	else		
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{		
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+((LineCount+StartLine-1)<<9)+Width+StartPixel-1;
			for (int line=LineCount;line;line--,screen+=256-Width,pix-=8*64-Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ((*zb)>index_spr) {*screen=*pix;*zb=index_spr;}
				zb++;pix--;screen++;
			}
		}
		else //VFLIP
		{
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+((LineCount+StartLine-1)<<9)+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix-=8*64+Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ((*zb)>index_spr) {*screen=*pix;*zb=index_spr;}
				zb++;pix++;screen++;
			}
		}
    }
    else //transparent (partially) tile
    {			
    	
		if (!(Tile & (V_FLIP | H_FLIP))) //NO FLIP
		{	
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+(StartLine<<9)+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix+=8*64-Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{				
				if ( ((*pix)!=(1<<5)) &&((*zb)>index_spr)) {*screen=*pix;*zb=index_spr;}
				zb++;pix++;screen++;
			}
		}
    	else
    	if (!(Tile & V_FLIP)) //HFLIP
		{
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+(StartLine<<9)+Width+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix+=8*64+Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ( ((*pix)!=(1<<5)) &&((*zb)>index_spr)) {*screen=*pix;*zb=index_spr;}
				zb++;pix--;screen++;
			}
		}
    	else		
    	if (Tile & H_FLIP) //VFLIP & HFLIP
		{		
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+((LineCount+StartLine)<<9)+Width+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix-=8*64-Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ( ((*pix)!=(1<<5)) &&((*zb)>index_spr)) {*screen=*pix;*zb=index_spr;}
				zb++;pix--;screen++;
			}
		}
		else //VFLIP
		{
			uint16 *screen=((uint16*)GFX.Screen)+Offset+StartPixel;
			uint8  *zb=GFX.ZBuffer+Offset+StartPixel;
			uint16 *pix=((uint16*)pCache)+((LineCount+StartLine)<<9)+StartPixel;
			for (int line=LineCount;line;line--,screen+=256-Width,pix-=8*64+Width,zb+=256-Width)
			for (int i=Width;i;i--)
			{
				if ( ((*pix)!=(1<<5)) &&((*zb)>index_spr)) {*screen=*pix;*zb=index_spr;}
				zb++;pix++;screen++;
			}
		}
    }
}

void DrawHiResTile16New (uint32 Tile, uint32 Offset, uint32 StartLine, uint32 LineCount)
{
return;
#if 0	
    uint8 *pCache;
    uint32 Col;
    uint32 TileAddr = BG.TileAddress + ((Tile & 0x3ff) << BG.TileShift);
    if ((Tile & 0x1ff) >= 256) TileAddr += BG.NameSelect;
    TileAddr &= 0xffff;
    
    register uint32 l;
    if (BG.DirectColourMode)
    {
        //Did the palette changed ?
		if (IPPU.DirectColourMapsNeedRebuild) S9xBuildDirectColourMaps ();
        GFX.ScreenColors = DirectColourMaps [(Tile >> 10) & BG.PaletteMask];
        Col = 0;
    }
    else 
    {
    	GFX.ScreenColors = &IPPU.ScreenColors [(((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette];
    	Col = (((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette;
    }
    
    uint32 TileNumber;
    pCache = &BG.Buffer[(TileNumber = (TileAddr >> BG.TileShift)) *(128+8)];
    
    
	if ((!BG.Buffered [TileNumber<<1])|(BG.Buffered [(TileNumber<<1)|1]!=Col)) 
    {
    	BG.Buffered[TileNumber<<1] = ConvertTile16New (pCache, TileAddr,GFX.ScreenColors);
	   	BG.Buffered[(TileNumber<<1)|1] = Col;
	}
    

    if (BG.Buffered [TileNumber<<1] == 1) //BLANK_TILE
		return;	        
    //Tile is not blank, 'have to draw it        


    register uint8 *bp,*headerbp;    	
    uint32 solid_lineclip;
    switch (StartLine)
	{
		case 0:solid_lineclip=0x00;break;
		case 1:solid_lineclip=0x80;break;
		case 2:solid_lineclip=0xC0;break;
		case 3:solid_lineclip=0xE0;break;
		case 4:solid_lineclip=0xF0;break;
		case 5:solid_lineclip=0xF8;break;
		case 6:solid_lineclip=0xFC;break;
		case 7:solid_lineclip=0xFE;break;
	}
	switch (StartLine+LineCount) //EndLine
	{
		case 1:solid_lineclip|=0x7F;break;
		case 2:solid_lineclip|=0x3F;break;
		case 3:solid_lineclip|=0x1F;break;
		case 4:	solid_lineclip|=0x0F;break;
		case 5:	solid_lineclip|=0x07;break;
		case 6:	solid_lineclip|=0x03;break;
		case 7:	solid_lineclip|=0x01;break;

	}
	
	if (solid_lineclip==0xFF) return;
	
	if ( (BG.Buffered [TileNumber<<1] == 2)&&(!solid_lineclip))
	{

		Offset += StartLine; //align to tile multiple    
	    if (!(Tile & (V_FLIP | H_FLIP)))
	    {
		    //NO FLIP
		  
			bp = pCache+8;
					
			for (l = 4; l != 0; l--, bp += 8*2*2, Offset+=240)
			   	NORMAL16_O (Offset, (uint16*)bp);						
	    }
	    else
	    if (!(Tile & V_FLIP))
	    {
	    	//HFLIP
		
			bp = pCache+8;
			Offset += 3*240;
	    	for (l = 4; l != 0; l--, bp += 8*2*2, Offset-=240)
		    	NORMAL16_O (Offset, (uint16*)bp);
	    }
	    else
	    if (Tile & H_FLIP)
	    {
	    	//VFLIP & HFLIP
	   		
			bp = pCache+8;
			Offset += 3*240;

	    	for (l = 4; l != 0; l--, bp += 8*2*2, Offset-=240)
		    	FLIPPED16_O (Offset, (uint16*)bp);

	    }
	    else
	    {
		    //VFLIP
	   		
		 
			bp = pCache+8;
	    	for (l = 4; l != 0; l--, bp += 8*2*2, Offset+=240)
		    	FLIPPED16_O (Offset, (uint16*)bp);

		}
	}
	else
	{
		Offset += StartLine; //align to tile multiple    
	    if (!(Tile & (V_FLIP | H_FLIP)))
	    {
		    //NO FLIP
		    headerbp = pCache;
			bp = pCache+8;
					
			for (l = 4; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset+=240)
			   	NORMAL16_T (Offset, (uint16*)bp,solid_lineclip|*headerbp);						
	    }
	    else
	    if (!(Tile & V_FLIP))
	    {
	    	//HFLIP
		    headerbp = pCache;
			bp = pCache+8;
			Offset += 3*240;
	    	for (l = 4; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset-=240)
		    	NORMAL16_T (Offset, (uint16*)bp,solid_lineclip|*headerbp);
	    }
	    else
	    if (Tile & H_FLIP)
	    {
	    	//VFLIP & HFLIP
	   		uint8 solid_lineclipI;
	   		solid_lineclipI=0;
	   		for (int i=0;i<8;i++)
	   		{
		   		solid_lineclipI<<=1;
	   			if (solid_lineclip & (1<<i)) solid_lineclipI|=1;   			
	   		}
		    headerbp = pCache;
			bp = pCache+8;
			Offset += 3*240;

	    	for (l = 4; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset-=240)
		    	FLIPPED16_T (Offset, (uint16*)bp,solid_lineclipI|*headerbp);

	    }
	    else
	    {
		    //VFLIP
	   		uint8 solid_lineclipI;
	   		solid_lineclipI=0;
	   		for (int i=0;i<8;i++)
	   		{
	  			solid_lineclipI<<=1;
	   			if (solid_lineclip & (1<<i)) solid_lineclipI|=1;
	   		}
		    
		    headerbp = pCache;
			bp = pCache+8;
	    	for (l = 4; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset+=240)
		    	FLIPPED16_T (Offset, (uint16*)bp,solid_lineclipI|*headerbp);

		}
	}
#endif	
}

void DrawHiResClippedTile16New (uint32 Tile, uint32 Offset,
			uint32 StartPixel, uint32 Width,
			uint32 StartLine, uint32 LineCount)
{
return;
#if 0	
    uint8 *pCache;
    uint32 Col;
    uint32 TileAddr = BG.TileAddress + ((Tile & 0x3ff) << BG.TileShift);
    if ((Tile & 0x1ff) >= 256) TileAddr += BG.NameSelect;
    TileAddr &= 0xffff;
    
    register uint32 l;
    if (BG.DirectColourMode)
    {
        //Did the palette changed ?
		if (IPPU.DirectColourMapsNeedRebuild) S9xBuildDirectColourMaps ();
        GFX.ScreenColors = DirectColourMaps [(Tile >> 10) & BG.PaletteMask];
        Col = 0;
    }
    else 
    {
    	GFX.ScreenColors = &IPPU.ScreenColors [(((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette];
    	Col = (((Tile >> 10) & BG.PaletteMask) << BG.PaletteShift) + BG.StartPalette;
    }
    
    uint32 TileNumber;
    pCache = &BG.Buffer[(TileNumber = (TileAddr >> BG.TileShift)) *(128+8)];
    

    
	if ((!BG.Buffered [TileNumber<<1])|(BG.Buffered [(TileNumber<<1)|1]!=Col)) 
    {
    	BG.Buffered[TileNumber<<1] = ConvertTile16New (pCache, TileAddr,GFX.ScreenColors);
	   	BG.Buffered[(TileNumber<<1)|1] = Col;
	}
    

    if (BG.Buffered [TileNumber<<1] == 1) //BLANK_TILE
		return;	        
    //Tile is not blank, 'have to draw it        


    register uint8 *bp,*headerbp;    	
    uint32 solid_lineclip;
    switch (StartLine)
	{
		case 0:solid_lineclip=0x00;break;
		case 1:solid_lineclip=0x80;break;
		case 2:solid_lineclip=0xC0;break;
		case 3:solid_lineclip=0xE0;break;
		case 4:solid_lineclip=0xF0;break;
		case 5:solid_lineclip=0xF8;break;
		case 6:solid_lineclip=0xFC;break;
		case 7:solid_lineclip=0xFE;break;
	}
	switch (StartLine+LineCount) //EndLine
	{
		case 1:solid_lineclip|=0x7F;break;
		case 2:solid_lineclip|=0x3F;break;
		case 3:solid_lineclip|=0x1F;break;
		case 4:	solid_lineclip|=0x0F;break;
		case 5:	solid_lineclip|=0x07;break;
		case 6:	solid_lineclip|=0x03;break;
		case 7:	solid_lineclip|=0x01;break;

	}
	
	if (solid_lineclip==0xFF) return;
	
	if ( (BG.Buffered [TileNumber<<1] == 2)&&(!solid_lineclip))
	{
		Offset += StartLine; //align to tile multiple    
	    if (!(Tile & (V_FLIP | H_FLIP)))
	    {
		    //NO FLIP		  
			bp = pCache+8 + StartPixel*16;
			Offset += (StartPixel>>1)*240;				
			for (l = Width>>1; l != 0; l--, bp += 8*2*2, Offset+=240)
			   	NORMAL16_O (Offset, (uint16*)bp);						
	    }
	    else
	    if (!(Tile & V_FLIP))
	    {
	    	//HFLIP		  
			bp = pCache+8+StartPixel*16;
			Offset += ((StartPixel+Width-1)>>1)*240;
	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, Offset-=240)
		    	NORMAL16_O (Offset, (uint16*)bp);
	    }
	    else
	    if (Tile & H_FLIP)
	    {
	    	//VFLIP & HFLIP
	   		
			bp = pCache+8+StartPixel*16;
			Offset += ((StartPixel+Width-1)>>1)*240;

	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, Offset-=240)
		    	FLIPPED16_O (Offset, (uint16*)bp);

	    }
	    else
	    {
		    //VFLIP
	   	
			bp = pCache+8+StartPixel*16;
			Offset += (StartPixel>>1)*240;
	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, Offset+=240)
		    	FLIPPED16_O (Offset, (uint16*)bp);

		}
	}
	else
	{

		Offset += StartLine; //align to tile multiple    
	    if (!(Tile & (V_FLIP | H_FLIP)))
	    {
		    //NO FLIP
		    headerbp = pCache+StartPixel;
			bp = pCache+8 + StartPixel*16;
			Offset += (StartPixel>>1)*240;				
			for (l = Width>>1; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset+=240)
			   	NORMAL16_T (Offset, (uint16*)bp,solid_lineclip|*headerbp);						
	    }
	    else
	    if (!(Tile & V_FLIP))
	    {
	    	//HFLIP
		    headerbp = pCache+StartPixel;
			bp = pCache+8+StartPixel*16;
			Offset += ((StartPixel+Width-1)>>1)*240;
	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset-=240)
		    	NORMAL16_T (Offset, (uint16*)bp,solid_lineclip|*headerbp);
	    }
	    else
	    if (Tile & H_FLIP)
	    {
	    	//VFLIP & HFLIP
	   		uint8 solid_lineclipI;
	   		solid_lineclipI=0;
	   		for (int i=0;i<8;i++)
	   		{
	   			solid_lineclipI<<=1;   		
	   			if (solid_lineclip & (1<<i)) solid_lineclipI|=1;

	   		}
		    headerbp = pCache+StartPixel;
			bp = pCache+8+StartPixel*16;
			Offset += ((StartPixel+Width-1)>>1)*240;

	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset-=240)
		    	FLIPPED16_T (Offset, (uint16*)bp,solid_lineclipI|*headerbp);

	    }
	    else
	    {
		    //VFLIP
	   		uint8 solid_lineclipI;
	   		solid_lineclipI=0;
	   		for (int i=0;i<8;i++)
	   		{
	   			solid_lineclipI<<=1;   		
	   			if (solid_lineclip & (1<<i)) solid_lineclipI|=1;
	   		}
		    
		    headerbp = pCache+StartPixel;
			bp = pCache+8+StartPixel*16;
			Offset += (StartPixel>>1)*240;
	    	for (l = Width>>1; l != 0; l--, bp += 8*2*2, headerbp+=2, Offset+=240)
		    	FLIPPED16_T (Offset, (uint16*)bp,solid_lineclipI|*headerbp);

		}
	}
#endif	
}

#endif
